// ------------------------------------------------------------------
// Copyright (c) 2004-2007 Atheros Corporation.  All rights reserved.
// 
//
// Permission to use, copy, modify, and/or distribute this software for any
// purpose with or without fee is hereby granted, provided that the above
// copyright notice and this permission notice appear in all copies.
//
// THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
// WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
// MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
// ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
// WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
// ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
// OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
//
//
// ------------------------------------------------------------------
//===================================================================
// Author(s): ="Atheros"
//===================================================================


#ifdef WLAN_HEADERS

#include "rtc_wlan_reg.h"
#include "rtc_soc_reg.h"
#include "rtc_sync_reg.h"
#include "fpga_reg.h"


#ifndef BT_HEADERS

#define RESET_CONTROL_MAC_WARM_RST_MSB WLAN_RESET_CONTROL_MAC_WARM_RST_MSB
#define RESET_CONTROL_MAC_WARM_RST_LSB WLAN_RESET_CONTROL_MAC_WARM_RST_LSB
#define RESET_CONTROL_MAC_WARM_RST_MASK WLAN_RESET_CONTROL_MAC_WARM_RST_MASK
#define RESET_CONTROL_MAC_WARM_RST_GET(x) WLAN_RESET_CONTROL_MAC_WARM_RST_GET(x)
#define RESET_CONTROL_MAC_WARM_RST_SET(x) WLAN_RESET_CONTROL_MAC_WARM_RST_SET(x)
#define RESET_CONTROL_MAC_COLD_RST_MSB WLAN_RESET_CONTROL_MAC_COLD_RST_MSB
#define RESET_CONTROL_MAC_COLD_RST_LSB WLAN_RESET_CONTROL_MAC_COLD_RST_LSB
#define RESET_CONTROL_MAC_COLD_RST_MASK WLAN_RESET_CONTROL_MAC_COLD_RST_MASK
#define RESET_CONTROL_MAC_COLD_RST_GET(x) WLAN_RESET_CONTROL_MAC_COLD_RST_GET(x)
#define RESET_CONTROL_MAC_COLD_RST_SET(x) WLAN_RESET_CONTROL_MAC_COLD_RST_SET(x)
#define RESET_CONTROL_WARM_RST_MSB WLAN_RESET_CONTROL_WARM_RST_MSB
#define RESET_CONTROL_WARM_RST_LSB WLAN_RESET_CONTROL_WARM_RST_LSB
#define RESET_CONTROL_WARM_RST_MASK WLAN_RESET_CONTROL_WARM_RST_MASK
#define RESET_CONTROL_WARM_RST_GET(x) WLAN_RESET_CONTROL_WARM_RST_GET(x)
#define RESET_CONTROL_WARM_RST_SET(x) WLAN_RESET_CONTROL_WARM_RST_SET(x)
#define RESET_CONTROL_BB_WARM_RST_MSB WLAN_RESET_CONTROL_BB_WARM_RST_MSB
#define RESET_CONTROL_BB_WARM_RST_LSB WLAN_RESET_CONTROL_BB_WARM_RST_LSB
#define RESET_CONTROL_BB_WARM_RST_MASK WLAN_RESET_CONTROL_BB_WARM_RST_MASK
#define RESET_CONTROL_BB_WARM_RST_GET(x) WLAN_RESET_CONTROL_BB_WARM_RST_GET(x)
#define RESET_CONTROL_BB_WARM_RST_SET(x) WLAN_RESET_CONTROL_BB_WARM_RST_SET(x)
#define RESET_CONTROL_BB_COLD_RST_MSB WLAN_RESET_CONTROL_BB_COLD_RST_MSB
#define RESET_CONTROL_BB_COLD_RST_LSB WLAN_RESET_CONTROL_BB_COLD_RST_LSB
#define RESET_CONTROL_BB_COLD_RST_MASK WLAN_RESET_CONTROL_BB_COLD_RST_MASK
#define RESET_CONTROL_BB_COLD_RST_GET(x) WLAN_RESET_CONTROL_BB_COLD_RST_GET(x)
#define RESET_CONTROL_BB_COLD_RST_SET(x) WLAN_RESET_CONTROL_BB_COLD_RST_SET(x)
#define RESET_CONTROL_RADIO_SRESET_MSB WLAN_RESET_CONTROL_RADIO_SRESET_MSB
#define RESET_CONTROL_RADIO_SRESET_LSB WLAN_RESET_CONTROL_RADIO_SRESET_LSB
#define RESET_CONTROL_RADIO_SRESET_MASK WLAN_RESET_CONTROL_RADIO_SRESET_MASK
#define RESET_CONTROL_RADIO_SRESET_GET(x) WLAN_RESET_CONTROL_RADIO_SRESET_GET(x)
#define RESET_CONTROL_RADIO_SRESET_SET(x) WLAN_RESET_CONTROL_RADIO_SRESET_SET(x)
#define RESET_CONTROL_MCI_RESET_MSB WLAN_RESET_CONTROL_MCI_RESET_MSB
#define RESET_CONTROL_MCI_RESET_LSB WLAN_RESET_CONTROL_MCI_RESET_LSB
#define RESET_CONTROL_MCI_RESET_MASK WLAN_RESET_CONTROL_MCI_RESET_MASK
#define RESET_CONTROL_MCI_RESET_GET(x) WLAN_RESET_CONTROL_MCI_RESET_GET(x)
#define RESET_CONTROL_MCI_RESET_SET(x) WLAN_RESET_CONTROL_MCI_RESET_SET(x)
#define XTAL_CONTROL_TCXO_MSB WLAN_XTAL_CONTROL_TCXO_MSB
#define XTAL_CONTROL_TCXO_LSB WLAN_XTAL_CONTROL_TCXO_LSB
#define XTAL_CONTROL_TCXO_MASK WLAN_XTAL_CONTROL_TCXO_MASK
#define XTAL_CONTROL_TCXO_GET(x) WLAN_XTAL_CONTROL_TCXO_GET(x)
#define XTAL_CONTROL_TCXO_SET(x) WLAN_XTAL_CONTROL_TCXO_SET(x)
#define REG_CONTROL0_SWREG_BITS_MSB WLAN_REG_CONTROL0_SWREG_BITS_MSB
#define REG_CONTROL0_SWREG_BITS_LSB WLAN_REG_CONTROL0_SWREG_BITS_LSB
#define REG_CONTROL0_SWREG_BITS_MASK WLAN_REG_CONTROL0_SWREG_BITS_MASK
#define REG_CONTROL0_SWREG_BITS_GET(x) WLAN_REG_CONTROL0_SWREG_BITS_GET(x)
#define REG_CONTROL0_SWREG_BITS_SET(x) WLAN_REG_CONTROL0_SWREG_BITS_SET(x)
#define REG_CONTROL1_SWREG_PROGRAM_MSB WLAN_REG_CONTROL1_SWREG_PROGRAM_MSB
#define REG_CONTROL1_SWREG_PROGRAM_LSB WLAN_REG_CONTROL1_SWREG_PROGRAM_LSB
#define REG_CONTROL1_SWREG_PROGRAM_MASK WLAN_REG_CONTROL1_SWREG_PROGRAM_MASK
#define REG_CONTROL1_SWREG_PROGRAM_GET(x) WLAN_REG_CONTROL1_SWREG_PROGRAM_GET(x)
#define REG_CONTROL1_SWREG_PROGRAM_SET(x) WLAN_REG_CONTROL1_SWREG_PROGRAM_SET(x)
#define REG_CONTROL1_OTPREG_LVL_MSB WLAN_REG_CONTROL1_OTPREG_LVL_MSB
#define REG_CONTROL1_OTPREG_LVL_LSB WLAN_REG_CONTROL1_OTPREG_LVL_LSB
#define REG_CONTROL1_OTPREG_LVL_MASK WLAN_REG_CONTROL1_OTPREG_LVL_MASK
#define REG_CONTROL1_OTPREG_LVL_GET(x) WLAN_REG_CONTROL1_OTPREG_LVL_GET(x)
#define REG_CONTROL1_OTPREG_LVL_SET(x) WLAN_REG_CONTROL1_OTPREG_LVL_SET(x)
#define QUADRATURE_DAC_MSB WLAN_QUADRATURE_DAC_MSB
#define QUADRATURE_DAC_LSB WLAN_QUADRATURE_DAC_LSB
#define QUADRATURE_DAC_MASK WLAN_QUADRATURE_DAC_MASK
#define QUADRATURE_DAC_GET(x) WLAN_QUADRATURE_DAC_GET(x)
#define QUADRATURE_DAC_SET(x) WLAN_QUADRATURE_DAC_SET(x)
#define QUADRATURE_ADC_MSB WLAN_QUADRATURE_ADC_MSB
#define QUADRATURE_ADC_LSB WLAN_QUADRATURE_ADC_LSB
#define QUADRATURE_ADC_MASK WLAN_QUADRATURE_ADC_MASK
#define QUADRATURE_ADC_GET(x) WLAN_QUADRATURE_ADC_GET(x)
#define QUADRATURE_ADC_SET(x) WLAN_QUADRATURE_ADC_SET(x)
#define PLL_CONTROL_DIV_MSB WLAN_PLL_CONTROL_DIV_MSB
#define PLL_CONTROL_DIV_LSB WLAN_PLL_CONTROL_DIV_LSB
#define PLL_CONTROL_DIV_MASK WLAN_PLL_CONTROL_DIV_MASK
#define PLL_CONTROL_DIV_GET(x) WLAN_PLL_CONTROL_DIV_GET(x)
#define PLL_CONTROL_DIV_SET(x) WLAN_PLL_CONTROL_DIV_SET(x)
#define PLL_CONTROL_REFDIV_MSB WLAN_PLL_CONTROL_REFDIV_MSB
#define PLL_CONTROL_REFDIV_LSB WLAN_PLL_CONTROL_REFDIV_LSB
#define PLL_CONTROL_REFDIV_MASK WLAN_PLL_CONTROL_REFDIV_MASK
#define PLL_CONTROL_REFDIV_GET(x) WLAN_PLL_CONTROL_REFDIV_GET(x)
#define PLL_CONTROL_REFDIV_SET(x) WLAN_PLL_CONTROL_REFDIV_SET(x)
#define PLL_CONTROL_CLK_SEL_MSB WLAN_PLL_CONTROL_CLK_SEL_MSB
#define PLL_CONTROL_CLK_SEL_LSB WLAN_PLL_CONTROL_CLK_SEL_LSB
#define PLL_CONTROL_CLK_SEL_MASK WLAN_PLL_CONTROL_CLK_SEL_MASK
#define PLL_CONTROL_CLK_SEL_GET(x) WLAN_PLL_CONTROL_CLK_SEL_GET(x)
#define PLL_CONTROL_CLK_SEL_SET(x) WLAN_PLL_CONTROL_CLK_SEL_SET(x)
#define PLL_CONTROL_BYPASS_MSB WLAN_PLL_CONTROL_BYPASS_MSB
#define PLL_CONTROL_BYPASS_LSB WLAN_PLL_CONTROL_BYPASS_LSB
#define PLL_CONTROL_BYPASS_MASK WLAN_PLL_CONTROL_BYPASS_MASK
#define PLL_CONTROL_BYPASS_GET(x) WLAN_PLL_CONTROL_BYPASS_GET(x)
#define PLL_CONTROL_BYPASS_SET(x) WLAN_PLL_CONTROL_BYPASS_SET(x)
#define PLL_CONTROL_UPDATING_MSB WLAN_PLL_CONTROL_UPDATING_MSB
#define PLL_CONTROL_UPDATING_LSB WLAN_PLL_CONTROL_UPDATING_LSB
#define PLL_CONTROL_UPDATING_MASK WLAN_PLL_CONTROL_UPDATING_MASK
#define PLL_CONTROL_UPDATING_GET(x) WLAN_PLL_CONTROL_UPDATING_GET(x)
#define PLL_CONTROL_NOPWD_MSB WLAN_PLL_CONTROL_NOPWD_MSB
#define PLL_CONTROL_NOPWD_LSB WLAN_PLL_CONTROL_NOPWD_LSB
#define PLL_CONTROL_NOPWD_MASK WLAN_PLL_CONTROL_NOPWD_MASK
#define PLL_CONTROL_NOPWD_GET(x) WLAN_PLL_CONTROL_NOPWD_GET(x)
#define PLL_CONTROL_NOPWD_SET(x) WLAN_PLL_CONTROL_NOPWD_SET(x)
#define PLL_CONTROL_MAC_OVERRIDE_MSB WLAN_PLL_CONTROL_MAC_OVERRIDE_MSB
#define PLL_CONTROL_MAC_OVERRIDE_LSB WLAN_PLL_CONTROL_MAC_OVERRIDE_LSB
#define PLL_CONTROL_MAC_OVERRIDE_MASK WLAN_PLL_CONTROL_MAC_OVERRIDE_MASK
#define PLL_CONTROL_MAC_OVERRIDE_GET(x) WLAN_PLL_CONTROL_MAC_OVERRIDE_GET(x)
#define PLL_CONTROL_MAC_OVERRIDE_SET(x) WLAN_PLL_CONTROL_MAC_OVERRIDE_SET(x)
#define PLL_CONTROL_DIG_TEST_CLK_MSB WLAN_PLL_CONTROL_DIG_TEST_CLK_MSB
#define PLL_CONTROL_DIG_TEST_CLK_LSB WLAN_PLL_CONTROL_DIG_TEST_CLK_LSB
#define PLL_CONTROL_DIG_TEST_CLK_MASK WLAN_PLL_CONTROL_DIG_TEST_CLK_MASK
#define PLL_CONTROL_DIG_TEST_CLK_GET(x) WLAN_PLL_CONTROL_DIG_TEST_CLK_GET(x)
#define PLL_CONTROL_DIG_TEST_CLK_SET(x) WLAN_PLL_CONTROL_DIG_TEST_CLK_SET(x)
#define PLL_SETTLE_TIME_MSB WLAN_PLL_SETTLE_TIME_MSB
#define PLL_SETTLE_TIME_LSB WLAN_PLL_SETTLE_TIME_LSB
#define PLL_SETTLE_TIME_MASK WLAN_PLL_SETTLE_TIME_MASK
#define PLL_SETTLE_TIME_GET(x) WLAN_PLL_SETTLE_TIME_GET(x)
#define PLL_SETTLE_TIME_SET(x) WLAN_PLL_SETTLE_TIME_SET(x)
#define XTAL_SETTLE_TIME_MSB WLAN_XTAL_SETTLE_TIME_MSB
#define XTAL_SETTLE_TIME_LSB WLAN_XTAL_SETTLE_TIME_LSB
#define XTAL_SETTLE_TIME_MASK WLAN_XTAL_SETTLE_TIME_MASK
#define XTAL_SETTLE_TIME_GET(x) WLAN_XTAL_SETTLE_TIME_GET(x)
#define XTAL_SETTLE_TIME_SET(x) WLAN_XTAL_SETTLE_TIME_SET(x)
#define CLOCK_OUT_SELECT_MSB WLAN_CLOCK_OUT_SELECT_MSB
#define CLOCK_OUT_SELECT_LSB WLAN_CLOCK_OUT_SELECT_LSB
#define CLOCK_OUT_SELECT_MASK WLAN_CLOCK_OUT_SELECT_MASK
#define CLOCK_OUT_SELECT_GET(x) WLAN_CLOCK_OUT_SELECT_GET(x)
#define CLOCK_OUT_SELECT_SET(x) WLAN_CLOCK_OUT_SELECT_SET(x)
#define CLOCK_OUT_DELAY_MSB WLAN_CLOCK_OUT_DELAY_MSB
#define CLOCK_OUT_DELAY_LSB WLAN_CLOCK_OUT_DELAY_LSB
#define CLOCK_OUT_DELAY_MASK WLAN_CLOCK_OUT_DELAY_MASK
#define CLOCK_OUT_DELAY_GET(x) WLAN_CLOCK_OUT_DELAY_GET(x)
#define CLOCK_OUT_DELAY_SET(x) WLAN_CLOCK_OUT_DELAY_SET(x)
#define BIAS_OVERRIDE_ON_MSB WLAN_BIAS_OVERRIDE_ON_MSB
#define BIAS_OVERRIDE_ON_LSB WLAN_BIAS_OVERRIDE_ON_LSB
#define BIAS_OVERRIDE_ON_MASK WLAN_BIAS_OVERRIDE_ON_MASK
#define BIAS_OVERRIDE_ON_GET(x) WLAN_BIAS_OVERRIDE_ON_GET(x)
#define BIAS_OVERRIDE_ON_SET(x) WLAN_BIAS_OVERRIDE_ON_SET(x)
#define MAC_SLEEP_CONTROL_ENABLE_MSB WLAN_MAC_SLEEP_CONTROL_ENABLE_MSB
#define MAC_SLEEP_CONTROL_ENABLE_LSB WLAN_MAC_SLEEP_CONTROL_ENABLE_LSB
#define MAC_SLEEP_CONTROL_ENABLE_MASK WLAN_MAC_SLEEP_CONTROL_ENABLE_MASK
#define MAC_SLEEP_CONTROL_ENABLE_GET(x) WLAN_MAC_SLEEP_CONTROL_ENABLE_GET(x)
#define MAC_SLEEP_CONTROL_ENABLE_SET(x) WLAN_MAC_SLEEP_CONTROL_ENABLE_SET(x)
#define MAC_SLEEP_CONTROL_RESERVED_MSB WLAN_MAC_SLEEP_CONTROL_RESERVED_MSB
#define MAC_SLEEP_CONTROL_RESERVED_LSB WLAN_MAC_SLEEP_CONTROL_RESERVED_LSB
#define MAC_SLEEP_CONTROL_RESERVED_MASK WLAN_MAC_SLEEP_CONTROL_RESERVED_MASK
#define MAC_SLEEP_CONTROL_RESERVED_GET(x) WLAN_MAC_SLEEP_CONTROL_RESERVED_GET(x)
#define MAC_SLEEP_CONTROL_RESERVED_SET(x) WLAN_MAC_SLEEP_CONTROL_RESERVED_SET(x)
#define MAC_SLEEP_CONTROL_HSEL_WMAC_ENABLE_MSB WLAN_MAC_SLEEP_CONTROL_HSEL_WMAC_ENABLE_MSB
#define MAC_SLEEP_CONTROL_HSEL_WMAC_ENABLE_LSB WLAN_MAC_SLEEP_CONTROL_HSEL_WMAC_ENABLE_LSB
#define MAC_SLEEP_CONTROL_HSEL_WMAC_ENABLE_MASK WLAN_MAC_SLEEP_CONTROL_HSEL_WMAC_ENABLE_MASK
#define MAC_SLEEP_CONTROL_HSEL_WMAC_ENABLE_GET(x) WLAN_MAC_SLEEP_CONTROL_HSEL_WMAC_ENABLE_GET(x)
#define MAC_SLEEP_CONTROL_HSEL_WMAC_ENABLE_SET(x) WLAN_MAC_SLEEP_CONTROL_HSEL_WMAC_ENABLE_SET(x)
#define KEEP_AWAKE_COUNT_MSB WLAN_KEEP_AWAKE_COUNT_MSB
#define KEEP_AWAKE_COUNT_LSB WLAN_KEEP_AWAKE_COUNT_LSB
#define KEEP_AWAKE_COUNT_MASK WLAN_KEEP_AWAKE_COUNT_MASK
#define KEEP_AWAKE_COUNT_GET(x) WLAN_KEEP_AWAKE_COUNT_GET(x)
#define KEEP_AWAKE_COUNT_SET(x) WLAN_KEEP_AWAKE_COUNT_SET(x)
#define DERIVED_RTC_CLK_PERIOD_MSB WLAN_DERIVED_RTC_CLK_PERIOD_MSB
#define DERIVED_RTC_CLK_PERIOD_LSB WLAN_DERIVED_RTC_CLK_PERIOD_LSB
#define DERIVED_RTC_CLK_PERIOD_MASK WLAN_DERIVED_RTC_CLK_PERIOD_MASK
#define DERIVED_RTC_CLK_PERIOD_GET(x) WLAN_DERIVED_RTC_CLK_PERIOD_GET(x)
#define DERIVED_RTC_CLK_PERIOD_SET(x) WLAN_DERIVED_RTC_CLK_PERIOD_SET(x)
#define DERIVED_RTC_CLK_EXTERNAL_DETECT_MSB WLAN_DERIVED_RTC_CLK_EXTERNAL_DETECT_MSB
#define DERIVED_RTC_CLK_EXTERNAL_DETECT_LSB WLAN_DERIVED_RTC_CLK_EXTERNAL_DETECT_LSB
#define DERIVED_RTC_CLK_EXTERNAL_DETECT_MASK WLAN_DERIVED_RTC_CLK_EXTERNAL_DETECT_MASK
#define DERIVED_RTC_CLK_EXTERNAL_DETECT_GET(x) WLAN_DERIVED_RTC_CLK_EXTERNAL_DETECT_GET(x)
#define DERIVED_RTC_CLK_EXTERNAL_DETECT_EN_MSB WLAN_DERIVED_RTC_CLK_EXTERNAL_DETECT_EN_MSB
#define DERIVED_RTC_CLK_EXTERNAL_DETECT_EN_LSB WLAN_DERIVED_RTC_CLK_EXTERNAL_DETECT_EN_LSB
#define DERIVED_RTC_CLK_EXTERNAL_DETECT_EN_MASK WLAN_DERIVED_RTC_CLK_EXTERNAL_DETECT_EN_MASK
#define DERIVED_RTC_CLK_EXTERNAL_DETECT_EN_GET(x) WLAN_DERIVED_RTC_CLK_EXTERNAL_DETECT_EN_GET(x)
#define DERIVED_RTC_CLK_EXTERNAL_DETECT_EN_SET(x) WLAN_DERIVED_RTC_CLK_EXTERNAL_DETECT_EN_SET(x)
#define MAC_PCU_WBTIMER_ADDRESS MAC_PCU_WBTIMER_0_ADDRESS
#define MAC_PCU_WBTIMER_OFFSET MAC_PCU_WBTIMER_0_OFFSET
#define MAC_PCU_WBTIMER_ENABLE_MSB MAC_PCU_WBTIMER_0_ENABLE_MSB
#define MAC_PCU_WBTIMER_ENABLE_LSB MAC_PCU_WBTIMER_0_ENABLE_LSB
#define MAC_PCU_WBTIMER_ENABLE_MASK MAC_PCU_WBTIMER_0_ENABLE_MASK
#define MAC_PCU_WBTIMER_ENABLE_GET(x) MAC_PCU_WBTIMER_0_ENABLE_GET(x)
#define MAC_PCU_WBTIMER_ENABLE_SET(x) MAC_PCU_WBTIMER_0_ENABLE_SET(x)
#define MAC_PCU_CAB_AWAKE_ADDRESS MAC_PCU_SLP3_ADDRESS
#define MAC_PCU_CAB_AWAKE_OFFSET MAC_PCU_SLP3_OFFSET
#define MAC_PCU_CAB_AWAKE_DURATION_MSB MAC_PCU_SLP3_CAB_AWAKE_DUR_MSB
#define MAC_PCU_CAB_AWAKE_DURATION_LSB MAC_PCU_SLP3_CAB_AWAKE_DUR_LSB
#define MAC_PCU_CAB_AWAKE_DURATION_MASK MAC_PCU_SLP3_CAB_AWAKE_DUR_MASK
#define MAC_PCU_CAB_AWAKE_DURATION_GET(x) MAC_PCU_SLP3_CAB_AWAKE_DUR_GET(x)
#define MAC_PCU_CAB_AWAKE_DURATION_SET(x) MAC_PCU_SLP3_CAB_AWAKE_DUR_SET(x)
#define MAC_PCU_CAB_AWAKE_ENABLE_MSB MAC_PCU_SLP3_CAB_AWAKE_ENABLE_MSB
#define MAC_PCU_CAB_AWAKE_ENABLE_LSB MAC_PCU_SLP3_CAB_AWAKE_ENABLE_LSB
#define MAC_PCU_CAB_AWAKE_ENABLE_MASK MAC_PCU_SLP3_CAB_AWAKE_ENABLE_MASK
#define MAC_PCU_CAB_AWAKE_ENABLE_GET(x) MAC_PCU_SLP3_CAB_AWAKE_ENABLE_GET(x)
#define MAC_PCU_CAB_AWAKE_ENABLE_SET(x) MAC_PCU_SLP3_CAB_AWAKE_ENABLE_SET(x)
#define HT_ADDRESS WLAN_HT_ADDRESS
#define HT_OFFSET WLAN_HT_OFFSET
#define HT_MODE_MSB WLAN_HT_MODE_MSB
#define HT_MODE_LSB WLAN_HT_MODE_LSB
#define HT_MODE_MASK WLAN_HT_MODE_MASK
#define HT_MODE_GET(x) WLAN_HT_MODE_GET(x)
#define HT_MODE_SET(x) WLAN_HT_MODE_SET(x)
#define RESET_CONTROL_ADDRESS SOC_RESET_CONTROL_ADDRESS
#define RESET_CONTROL_OFFSET SOC_RESET_CONTROL_OFFSET
#define RESET_CONTROL_SDIO2_RST_MSB SOC_RESET_CONTROL_SDIO2_RST_MSB
#define RESET_CONTROL_SDIO2_RST_LSB SOC_RESET_CONTROL_SDIO2_RST_LSB
#define RESET_CONTROL_SDIO2_RST_MASK SOC_RESET_CONTROL_SDIO2_RST_MASK
#define RESET_CONTROL_SDIO2_RST_GET(x) SOC_RESET_CONTROL_SDIO2_RST_GET(x)
#define RESET_CONTROL_SDIO2_RST_SET(x) SOC_RESET_CONTROL_SDIO2_RST_SET(x)
#define RESET_CONTROL_SPI2_RST_MSB SOC_RESET_CONTROL_SPI2_RST_MSB
#define RESET_CONTROL_SPI2_RST_LSB SOC_RESET_CONTROL_SPI2_RST_LSB
#define RESET_CONTROL_SPI2_RST_MASK SOC_RESET_CONTROL_SPI2_RST_MASK
#define RESET_CONTROL_SPI2_RST_GET(x) SOC_RESET_CONTROL_SPI2_RST_GET(x)
#define RESET_CONTROL_SPI2_RST_SET(x) SOC_RESET_CONTROL_SPI2_RST_SET(x)
#define RESET_CONTROL_I2S_1_RST_MSB SOC_RESET_CONTROL_I2S_1_RST_MSB
#define RESET_CONTROL_I2S_1_RST_LSB SOC_RESET_CONTROL_I2S_1_RST_LSB
#define RESET_CONTROL_I2S_1_RST_MASK SOC_RESET_CONTROL_I2S_1_RST_MASK
#define RESET_CONTROL_I2S_1_RST_GET(x) SOC_RESET_CONTROL_I2S_1_RST_GET(x)
#define RESET_CONTROL_I2S_1_RST_SET(x) SOC_RESET_CONTROL_I2S_1_RST_SET(x)
#define RESET_CONTROL_I2S_1_MBOX_RST_MSB SOC_RESET_CONTROL_I2S_1_MBOX_RST_MSB
#define RESET_CONTROL_I2S_1_MBOX_RST_LSB SOC_RESET_CONTROL_I2S_1_MBOX_RST_LSB
#define RESET_CONTROL_I2S_1_MBOX_RST_MASK SOC_RESET_CONTROL_I2S_1_MBOX_RST_MASK
#define RESET_CONTROL_I2S_1_MBOX_RST_GET(x) SOC_RESET_CONTROL_I2S_1_MBOX_RST_GET(x)
#define RESET_CONTROL_I2S_1_MBOX_RST_SET(x) SOC_RESET_CONTROL_I2S_1_MBOX_RST_SET(x)
#define RESET_CONTROL_I2C_SLAVE_RST_MSB SOC_RESET_CONTROL_I2C_SLAVE_RST_MSB
#define RESET_CONTROL_I2C_SLAVE_RST_LSB SOC_RESET_CONTROL_I2C_SLAVE_RST_LSB
#define RESET_CONTROL_I2C_SLAVE_RST_MASK SOC_RESET_CONTROL_I2C_SLAVE_RST_MASK
#define RESET_CONTROL_I2C_SLAVE_RST_GET(x) SOC_RESET_CONTROL_I2C_SLAVE_RST_GET(x)
#define RESET_CONTROL_I2C_SLAVE_RST_SET(x) SOC_RESET_CONTROL_I2C_SLAVE_RST_SET(x)
#define RESET_CONTROL_USB_PHY_ARST_MSB SOC_RESET_CONTROL_USB_PHY_ARST_MSB
#define RESET_CONTROL_USB_PHY_ARST_LSB SOC_RESET_CONTROL_USB_PHY_ARST_LSB
#define RESET_CONTROL_USB_PHY_ARST_MASK SOC_RESET_CONTROL_USB_PHY_ARST_MASK
#define RESET_CONTROL_USB_PHY_ARST_GET(x) SOC_RESET_CONTROL_USB_PHY_ARST_GET(x)
#define RESET_CONTROL_USB_PHY_ARST_SET(x) SOC_RESET_CONTROL_USB_PHY_ARST_SET(x)
#define RESET_CONTROL_USB_PHY_RST_MSB SOC_RESET_CONTROL_USB_PHY_RST_MSB
#define RESET_CONTROL_USB_PHY_RST_LSB SOC_RESET_CONTROL_USB_PHY_RST_LSB
#define RESET_CONTROL_USB_PHY_RST_MASK SOC_RESET_CONTROL_USB_PHY_RST_MASK
#define RESET_CONTROL_USB_PHY_RST_GET(x) SOC_RESET_CONTROL_USB_PHY_RST_GET(x)
#define RESET_CONTROL_USB_PHY_RST_SET(x) SOC_RESET_CONTROL_USB_PHY_RST_SET(x)
#define RESET_CONTROL_USB_RST_MSB SOC_RESET_CONTROL_USB_RST_MSB
#define RESET_CONTROL_USB_RST_LSB SOC_RESET_CONTROL_USB_RST_LSB
#define RESET_CONTROL_USB_RST_MASK SOC_RESET_CONTROL_USB_RST_MASK
#define RESET_CONTROL_USB_RST_GET(x) SOC_RESET_CONTROL_USB_RST_GET(x)
#define RESET_CONTROL_USB_RST_SET(x) SOC_RESET_CONTROL_USB_RST_SET(x)
#define RESET_CONTROL_MMAC_RST_MSB SOC_RESET_CONTROL_MMAC_RST_MSB
#define RESET_CONTROL_MMAC_RST_LSB SOC_RESET_CONTROL_MMAC_RST_LSB
#define RESET_CONTROL_MMAC_RST_MASK SOC_RESET_CONTROL_MMAC_RST_MASK
#define RESET_CONTROL_MMAC_RST_GET(x) SOC_RESET_CONTROL_MMAC_RST_GET(x)
#define RESET_CONTROL_MMAC_RST_SET(x) SOC_RESET_CONTROL_MMAC_RST_SET(x)
#define RESET_CONTROL_MDIO_RST_MSB SOC_RESET_CONTROL_MDIO_RST_MSB
#define RESET_CONTROL_MDIO_RST_LSB SOC_RESET_CONTROL_MDIO_RST_LSB
#define RESET_CONTROL_MDIO_RST_MASK SOC_RESET_CONTROL_MDIO_RST_MASK
#define RESET_CONTROL_MDIO_RST_GET(x) SOC_RESET_CONTROL_MDIO_RST_GET(x)
#define RESET_CONTROL_MDIO_RST_SET(x) SOC_RESET_CONTROL_MDIO_RST_SET(x)
#define RESET_CONTROL_GE0_RST_MSB SOC_RESET_CONTROL_GE0_RST_MSB
#define RESET_CONTROL_GE0_RST_LSB SOC_RESET_CONTROL_GE0_RST_LSB
#define RESET_CONTROL_GE0_RST_MASK SOC_RESET_CONTROL_GE0_RST_MASK
#define RESET_CONTROL_GE0_RST_GET(x) SOC_RESET_CONTROL_GE0_RST_GET(x)
#define RESET_CONTROL_GE0_RST_SET(x) SOC_RESET_CONTROL_GE0_RST_SET(x)
#define RESET_CONTROL_I2S_RST_MSB SOC_RESET_CONTROL_I2S_RST_MSB
#define RESET_CONTROL_I2S_RST_LSB SOC_RESET_CONTROL_I2S_RST_LSB
#define RESET_CONTROL_I2S_RST_MASK SOC_RESET_CONTROL_I2S_RST_MASK
#define RESET_CONTROL_I2S_RST_GET(x) SOC_RESET_CONTROL_I2S_RST_GET(x)
#define RESET_CONTROL_I2S_RST_SET(x) SOC_RESET_CONTROL_I2S_RST_SET(x)
#define RESET_CONTROL_I2S_MBOX_RST_MSB SOC_RESET_CONTROL_I2S_MBOX_RST_MSB
#define RESET_CONTROL_I2S_MBOX_RST_LSB SOC_RESET_CONTROL_I2S_MBOX_RST_LSB
#define RESET_CONTROL_I2S_MBOX_RST_MASK SOC_RESET_CONTROL_I2S_MBOX_RST_MASK
#define RESET_CONTROL_I2S_MBOX_RST_GET(x) SOC_RESET_CONTROL_I2S_MBOX_RST_GET(x)
#define RESET_CONTROL_I2S_MBOX_RST_SET(x) SOC_RESET_CONTROL_I2S_MBOX_RST_SET(x)
#define RESET_CONTROL_CHECKSUM_ACC_RST_MSB SOC_RESET_CONTROL_CHECKSUM_ACC_RST_MSB
#define RESET_CONTROL_CHECKSUM_ACC_RST_LSB SOC_RESET_CONTROL_CHECKSUM_ACC_RST_LSB
#define RESET_CONTROL_CHECKSUM_ACC_RST_MASK SOC_RESET_CONTROL_CHECKSUM_ACC_RST_MASK
#define RESET_CONTROL_CHECKSUM_ACC_RST_GET(x) SOC_RESET_CONTROL_CHECKSUM_ACC_RST_GET(x)
#define RESET_CONTROL_CHECKSUM_ACC_RST_SET(x) SOC_RESET_CONTROL_CHECKSUM_ACC_RST_SET(x)
#define RESET_CONTROL_UART2_RST_MSB SOC_RESET_CONTROL_UART2_RST_MSB
#define RESET_CONTROL_UART2_RST_LSB SOC_RESET_CONTROL_UART2_RST_LSB
#define RESET_CONTROL_UART2_RST_MASK SOC_RESET_CONTROL_UART2_RST_MASK
#define RESET_CONTROL_UART2_RST_GET(x) SOC_RESET_CONTROL_UART2_RST_GET(x)
#define RESET_CONTROL_UART2_RST_SET(x) SOC_RESET_CONTROL_UART2_RST_SET(x)
#define RESET_CONTROL_DEBUG_UART_RST_MSB SOC_RESET_CONTROL_DEBUG_UART_RST_MSB
#define RESET_CONTROL_DEBUG_UART_RST_LSB SOC_RESET_CONTROL_DEBUG_UART_RST_LSB
#define RESET_CONTROL_DEBUG_UART_RST_MASK SOC_RESET_CONTROL_DEBUG_UART_RST_MASK
#define RESET_CONTROL_DEBUG_UART_RST_GET(x) SOC_RESET_CONTROL_DEBUG_UART_RST_GET(x)
#define RESET_CONTROL_DEBUG_UART_RST_SET(x) SOC_RESET_CONTROL_DEBUG_UART_RST_SET(x)
#define RESET_CONTROL_MIT_REG_MAPPING_RST_MSB SOC_RESET_CONTROL_MIT_REG_MAPPING_RST_MSB
#define RESET_CONTROL_MIT_REG_MAPPING_RST_LSB SOC_RESET_CONTROL_MIT_REG_MAPPING_RST_LSB
#define RESET_CONTROL_MIT_REG_MAPPING_RST_MASK SOC_RESET_CONTROL_MIT_REG_MAPPING_RST_MASK
#define RESET_CONTROL_MIT_REG_MAPPING_RST_GET(x) SOC_RESET_CONTROL_MIT_REG_MAPPING_RST_GET(x)
#define RESET_CONTROL_MIT_REG_MAPPING_RST_SET(x) SOC_RESET_CONTROL_MIT_REG_MAPPING_RST_SET(x)
#define RESET_CONTROL_MIT_ADAPTOR_RST_MSB SOC_RESET_CONTROL_MIT_ADAPTOR_RST_MSB
#define RESET_CONTROL_MIT_ADAPTOR_RST_LSB SOC_RESET_CONTROL_MIT_ADAPTOR_RST_LSB
#define RESET_CONTROL_MIT_ADAPTOR_RST_MASK SOC_RESET_CONTROL_MIT_ADAPTOR_RST_MASK
#define RESET_CONTROL_MIT_ADAPTOR_RST_GET(x) SOC_RESET_CONTROL_MIT_ADAPTOR_RST_GET(x)
#define RESET_CONTROL_MIT_ADAPTOR_RST_SET(x) SOC_RESET_CONTROL_MIT_ADAPTOR_RST_SET(x)
#define RESET_CONTROL_CPU_INIT_RESET_MSB SOC_RESET_CONTROL_CPU_INIT_RESET_MSB
#define RESET_CONTROL_CPU_INIT_RESET_LSB SOC_RESET_CONTROL_CPU_INIT_RESET_LSB
#define RESET_CONTROL_CPU_INIT_RESET_MASK SOC_RESET_CONTROL_CPU_INIT_RESET_MASK
#define RESET_CONTROL_CPU_INIT_RESET_GET(x) SOC_RESET_CONTROL_CPU_INIT_RESET_GET(x)
#define RESET_CONTROL_CPU_INIT_RESET_SET(x) SOC_RESET_CONTROL_CPU_INIT_RESET_SET(x)
#define RESET_CONTROL_RST_OUT_MSB SOC_RESET_CONTROL_RST_OUT_MSB
#define RESET_CONTROL_RST_OUT_LSB SOC_RESET_CONTROL_RST_OUT_LSB
#define RESET_CONTROL_RST_OUT_MASK SOC_RESET_CONTROL_RST_OUT_MASK
#define RESET_CONTROL_RST_OUT_GET(x) SOC_RESET_CONTROL_RST_OUT_GET(x)
#define RESET_CONTROL_RST_OUT_SET(x) SOC_RESET_CONTROL_RST_OUT_SET(x)
#define RESET_CONTROL_COLD_RST_MSB SOC_RESET_CONTROL_COLD_RST_MSB
#define RESET_CONTROL_COLD_RST_LSB SOC_RESET_CONTROL_COLD_RST_LSB
#define RESET_CONTROL_COLD_RST_MASK SOC_RESET_CONTROL_COLD_RST_MASK
#define RESET_CONTROL_COLD_RST_GET(x) SOC_RESET_CONTROL_COLD_RST_GET(x)
#define RESET_CONTROL_COLD_RST_SET(x) SOC_RESET_CONTROL_COLD_RST_SET(x)
#define RESET_CONTROL_CPU_WARM_RST_MSB SOC_RESET_CONTROL_CPU_WARM_RST_MSB
#define RESET_CONTROL_CPU_WARM_RST_LSB SOC_RESET_CONTROL_CPU_WARM_RST_LSB
#define RESET_CONTROL_CPU_WARM_RST_MASK SOC_RESET_CONTROL_CPU_WARM_RST_MASK
#define RESET_CONTROL_CPU_WARM_RST_GET(x) SOC_RESET_CONTROL_CPU_WARM_RST_GET(x)
#define RESET_CONTROL_CPU_WARM_RST_SET(x) SOC_RESET_CONTROL_CPU_WARM_RST_SET(x)
#define RESET_CONTROL_MBOX_RST_MSB SOC_RESET_CONTROL_MBOX_RST_MSB
#define RESET_CONTROL_MBOX_RST_LSB SOC_RESET_CONTROL_MBOX_RST_LSB
#define RESET_CONTROL_MBOX_RST_MASK SOC_RESET_CONTROL_MBOX_RST_MASK
#define RESET_CONTROL_MBOX_RST_GET(x) SOC_RESET_CONTROL_MBOX_RST_GET(x)
#define RESET_CONTROL_MBOX_RST_SET(x) SOC_RESET_CONTROL_MBOX_RST_SET(x)
#define RESET_CONTROL_UART_RST_MSB SOC_RESET_CONTROL_UART_RST_MSB
#define RESET_CONTROL_UART_RST_LSB SOC_RESET_CONTROL_UART_RST_LSB
#define RESET_CONTROL_UART_RST_MASK SOC_RESET_CONTROL_UART_RST_MASK
#define RESET_CONTROL_UART_RST_GET(x) SOC_RESET_CONTROL_UART_RST_GET(x)
#define RESET_CONTROL_UART_RST_SET(x) SOC_RESET_CONTROL_UART_RST_SET(x)
#define RESET_CONTROL_SI0_RST_MSB SOC_RESET_CONTROL_SI0_RST_MSB
#define RESET_CONTROL_SI0_RST_LSB SOC_RESET_CONTROL_SI0_RST_LSB
#define RESET_CONTROL_SI0_RST_MASK SOC_RESET_CONTROL_SI0_RST_MASK
#define RESET_CONTROL_SI0_RST_GET(x) SOC_RESET_CONTROL_SI0_RST_GET(x)
#define RESET_CONTROL_SI0_RST_SET(x) SOC_RESET_CONTROL_SI0_RST_SET(x)
#define TCXO_DETECT_ADDRESS SOC_TCXO_DETECT_ADDRESS
#define TCXO_DETECT_OFFSET SOC_TCXO_DETECT_OFFSET
#define TCXO_DETECT_PRESENT_MSB SOC_TCXO_DETECT_PRESENT_MSB
#define TCXO_DETECT_PRESENT_LSB SOC_TCXO_DETECT_PRESENT_LSB
#define TCXO_DETECT_PRESENT_MASK SOC_TCXO_DETECT_PRESENT_MASK
#define TCXO_DETECT_PRESENT_GET(x) SOC_TCXO_DETECT_PRESENT_GET(x)
#define TCXO_DETECT_PRESENT_SET(x) SOC_TCXO_DETECT_PRESENT_SET(x)
#define XTAL_TEST_ADDRESS SOC_XTAL_TEST_ADDRESS
#define XTAL_TEST_OFFSET SOC_XTAL_TEST_OFFSET
#define XTAL_TEST_NOTCXODET_MSB SOC_XTAL_TEST_NOTCXODET_MSB
#define XTAL_TEST_NOTCXODET_LSB SOC_XTAL_TEST_NOTCXODET_LSB
#define XTAL_TEST_NOTCXODET_MASK SOC_XTAL_TEST_NOTCXODET_MASK
#define XTAL_TEST_NOTCXODET_GET(x) SOC_XTAL_TEST_NOTCXODET_GET(x)
#define XTAL_TEST_NOTCXODET_SET(x) SOC_XTAL_TEST_NOTCXODET_SET(x)
#define CPU_CLOCK_ADDRESS SOC_CPU_CLOCK_ADDRESS
#define CPU_CLOCK_OFFSET SOC_CPU_CLOCK_OFFSET
#define CPU_CLOCK_STANDARD_MSB SOC_CPU_CLOCK_STANDARD_MSB
#define CPU_CLOCK_STANDARD_LSB SOC_CPU_CLOCK_STANDARD_LSB
#define CPU_CLOCK_STANDARD_MASK SOC_CPU_CLOCK_STANDARD_MASK
#define CPU_CLOCK_STANDARD_GET(x) SOC_CPU_CLOCK_STANDARD_GET(x)
#define CPU_CLOCK_STANDARD_SET(x) SOC_CPU_CLOCK_STANDARD_SET(x)
#define CLOCK_CONTROL_ADDRESS SOC_CLOCK_CONTROL_ADDRESS
#define CLOCK_CONTROL_OFFSET SOC_CLOCK_CONTROL_OFFSET
#define CLOCK_CONTROL_LF_CLK32_MSB SOC_CLOCK_CONTROL_LF_CLK32_MSB
#define CLOCK_CONTROL_LF_CLK32_LSB SOC_CLOCK_CONTROL_LF_CLK32_LSB
#define CLOCK_CONTROL_LF_CLK32_MASK SOC_CLOCK_CONTROL_LF_CLK32_MASK
#define CLOCK_CONTROL_LF_CLK32_GET(x) SOC_CLOCK_CONTROL_LF_CLK32_GET(x)
#define CLOCK_CONTROL_LF_CLK32_SET(x) SOC_CLOCK_CONTROL_LF_CLK32_SET(x)
#define CLOCK_CONTROL_SI0_CLK_MSB SOC_CLOCK_CONTROL_SI0_CLK_MSB
#define CLOCK_CONTROL_SI0_CLK_LSB SOC_CLOCK_CONTROL_SI0_CLK_LSB
#define CLOCK_CONTROL_SI0_CLK_MASK SOC_CLOCK_CONTROL_SI0_CLK_MASK
#define CLOCK_CONTROL_SI0_CLK_GET(x) SOC_CLOCK_CONTROL_SI0_CLK_GET(x)
#define CLOCK_CONTROL_SI0_CLK_SET(x) SOC_CLOCK_CONTROL_SI0_CLK_SET(x)
#define WDT_CONTROL_ADDRESS SOC_WDT_CONTROL_ADDRESS
#define WDT_CONTROL_OFFSET SOC_WDT_CONTROL_OFFSET
#define WDT_CONTROL_ACTION_MSB SOC_WDT_CONTROL_ACTION_MSB
#define WDT_CONTROL_ACTION_LSB SOC_WDT_CONTROL_ACTION_LSB
#define WDT_CONTROL_ACTION_MASK SOC_WDT_CONTROL_ACTION_MASK
#define WDT_CONTROL_ACTION_GET(x) SOC_WDT_CONTROL_ACTION_GET(x)
#define WDT_CONTROL_ACTION_SET(x) SOC_WDT_CONTROL_ACTION_SET(x)
#define WDT_STATUS_ADDRESS SOC_WDT_STATUS_ADDRESS
#define WDT_STATUS_OFFSET SOC_WDT_STATUS_OFFSET
#define WDT_STATUS_INTERRUPT_MSB SOC_WDT_STATUS_INTERRUPT_MSB
#define WDT_STATUS_INTERRUPT_LSB SOC_WDT_STATUS_INTERRUPT_LSB
#define WDT_STATUS_INTERRUPT_MASK SOC_WDT_STATUS_INTERRUPT_MASK
#define WDT_STATUS_INTERRUPT_GET(x) SOC_WDT_STATUS_INTERRUPT_GET(x)
#define WDT_STATUS_INTERRUPT_SET(x) SOC_WDT_STATUS_INTERRUPT_SET(x)
#define WDT_ADDRESS SOC_WDT_ADDRESS
#define WDT_OFFSET SOC_WDT_OFFSET
#define WDT_TARGET_MSB SOC_WDT_TARGET_MSB
#define WDT_TARGET_LSB SOC_WDT_TARGET_LSB
#define WDT_TARGET_MASK SOC_WDT_TARGET_MASK
#define WDT_TARGET_GET(x) SOC_WDT_TARGET_GET(x)
#define WDT_TARGET_SET(x) SOC_WDT_TARGET_SET(x)
#define WDT_COUNT_ADDRESS SOC_WDT_COUNT_ADDRESS
#define WDT_COUNT_OFFSET SOC_WDT_COUNT_OFFSET
#define WDT_COUNT_VALUE_MSB SOC_WDT_COUNT_VALUE_MSB
#define WDT_COUNT_VALUE_LSB SOC_WDT_COUNT_VALUE_LSB
#define WDT_COUNT_VALUE_MASK SOC_WDT_COUNT_VALUE_MASK
#define WDT_COUNT_VALUE_GET(x) SOC_WDT_COUNT_VALUE_GET(x)
#define WDT_COUNT_VALUE_SET(x) SOC_WDT_COUNT_VALUE_SET(x)
#define WDT_RESET_ADDRESS SOC_WDT_RESET_ADDRESS
#define WDT_RESET_OFFSET SOC_WDT_RESET_OFFSET
#define WDT_RESET_VALUE_MSB SOC_WDT_RESET_VALUE_MSB
#define WDT_RESET_VALUE_LSB SOC_WDT_RESET_VALUE_LSB
#define WDT_RESET_VALUE_MASK SOC_WDT_RESET_VALUE_MASK
#define WDT_RESET_VALUE_GET(x) SOC_WDT_RESET_VALUE_GET(x)
#define WDT_RESET_VALUE_SET(x) SOC_WDT_RESET_VALUE_SET(x)
#define INT_STATUS_ADDRESS SOC_INT_STATUS_ADDRESS
#define INT_STATUS_OFFSET SOC_INT_STATUS_OFFSET
#define INT_STATUS_STE_MBOX_MSB SOC_INT_STATUS_STE_MBOX_MSB
#define INT_STATUS_STE_MBOX_LSB SOC_INT_STATUS_STE_MBOX_LSB
#define INT_STATUS_STE_MBOX_MASK SOC_INT_STATUS_STE_MBOX_MASK
#define INT_STATUS_STE_MBOX_GET(x) SOC_INT_STATUS_STE_MBOX_GET(x)
#define INT_STATUS_STE_MBOX_SET(x) SOC_INT_STATUS_STE_MBOX_SET(x)
#define INT_STATUS_SDIO2_MBOX_MSB SOC_INT_STATUS_SDIO2_MBOX_MSB
#define INT_STATUS_SDIO2_MBOX_LSB SOC_INT_STATUS_SDIO2_MBOX_LSB
#define INT_STATUS_SDIO2_MBOX_MASK SOC_INT_STATUS_SDIO2_MBOX_MASK
#define INT_STATUS_SDIO2_MBOX_GET(x) SOC_INT_STATUS_SDIO2_MBOX_GET(x)
#define INT_STATUS_SDIO2_MBOX_SET(x) SOC_INT_STATUS_SDIO2_MBOX_SET(x)
#define INT_STATUS_USBDMA_MSB SOC_INT_STATUS_USBDMA_MSB
#define INT_STATUS_USBDMA_LSB SOC_INT_STATUS_USBDMA_LSB
#define INT_STATUS_USBDMA_MASK SOC_INT_STATUS_USBDMA_MASK
#define INT_STATUS_USBDMA_GET(x) SOC_INT_STATUS_USBDMA_GET(x)
#define INT_STATUS_USBDMA_SET(x) SOC_INT_STATUS_USBDMA_SET(x)
#define INT_STATUS_USBIP_MSB SOC_INT_STATUS_USBIP_MSB
#define INT_STATUS_USBIP_LSB SOC_INT_STATUS_USBIP_LSB
#define INT_STATUS_USBIP_MASK SOC_INT_STATUS_USBIP_MASK
#define INT_STATUS_USBIP_GET(x) SOC_INT_STATUS_USBIP_GET(x)
#define INT_STATUS_USBIP_SET(x) SOC_INT_STATUS_USBIP_SET(x)
#define INT_STATUS_MMAC_MSB SOC_INT_STATUS_MMAC_MSB
#define INT_STATUS_MMAC_LSB SOC_INT_STATUS_MMAC_LSB
#define INT_STATUS_MMAC_MASK SOC_INT_STATUS_MMAC_MASK
#define INT_STATUS_MMAC_GET(x) SOC_INT_STATUS_MMAC_GET(x)
#define INT_STATUS_MMAC_SET(x) SOC_INT_STATUS_MMAC_SET(x)
#define INT_STATUS_MIT_REG_ACCESS_MSB SOC_INT_STATUS_MIT_REG_ACCESS_MSB
#define INT_STATUS_MIT_REG_ACCESS_LSB SOC_INT_STATUS_MIT_REG_ACCESS_LSB
#define INT_STATUS_MIT_REG_ACCESS_MASK SOC_INT_STATUS_MIT_REG_ACCESS_MASK
#define INT_STATUS_MIT_REG_ACCESS_GET(x) SOC_INT_STATUS_MIT_REG_ACCESS_GET(x)
#define INT_STATUS_MIT_REG_ACCESS_SET(x) SOC_INT_STATUS_MIT_REG_ACCESS_SET(x)
#define INT_STATUS_FLIGHT_MODE_MSB SOC_INT_STATUS_FLIGHT_MODE_MSB
#define INT_STATUS_FLIGHT_MODE_LSB SOC_INT_STATUS_FLIGHT_MODE_LSB
#define INT_STATUS_FLIGHT_MODE_MASK SOC_INT_STATUS_FLIGHT_MODE_MASK
#define INT_STATUS_FLIGHT_MODE_GET(x) SOC_INT_STATUS_FLIGHT_MODE_GET(x)
#define INT_STATUS_FLIGHT_MODE_SET(x) SOC_INT_STATUS_FLIGHT_MODE_SET(x)
#define INT_STATUS_BBP_SLEEP_RISING_MSB SOC_INT_STATUS_BBP_SLEEP_RISING_MSB
#define INT_STATUS_BBP_SLEEP_RISING_LSB SOC_INT_STATUS_BBP_SLEEP_RISING_LSB
#define INT_STATUS_BBP_SLEEP_RISING_MASK SOC_INT_STATUS_BBP_SLEEP_RISING_MASK
#define INT_STATUS_BBP_SLEEP_RISING_GET(x) SOC_INT_STATUS_BBP_SLEEP_RISING_GET(x)
#define INT_STATUS_BBP_SLEEP_RISING_SET(x) SOC_INT_STATUS_BBP_SLEEP_RISING_SET(x)
#define INT_STATUS_RF_SLEEP_RISING_MSB SOC_INT_STATUS_RF_SLEEP_RISING_MSB
#define INT_STATUS_RF_SLEEP_RISING_LSB SOC_INT_STATUS_RF_SLEEP_RISING_LSB
#define INT_STATUS_RF_SLEEP_RISING_MASK SOC_INT_STATUS_RF_SLEEP_RISING_MASK
#define INT_STATUS_RF_SLEEP_RISING_GET(x) SOC_INT_STATUS_RF_SLEEP_RISING_GET(x)
#define INT_STATUS_RF_SLEEP_RISING_SET(x) SOC_INT_STATUS_RF_SLEEP_RISING_SET(x)
#define INT_STATUS_MODE_SWITCH_MSB SOC_INT_STATUS_MODE_SWITCH_MSB
#define INT_STATUS_MODE_SWITCH_LSB SOC_INT_STATUS_MODE_SWITCH_LSB
#define INT_STATUS_MODE_SWITCH_MASK SOC_INT_STATUS_MODE_SWITCH_MASK
#define INT_STATUS_MODE_SWITCH_GET(x) SOC_INT_STATUS_MODE_SWITCH_GET(x)
#define INT_STATUS_MODE_SWITCH_SET(x) SOC_INT_STATUS_MODE_SWITCH_SET(x)
#define INT_STATUS_HCI_UART_MSB SOC_INT_STATUS_HCI_UART_MSB
#define INT_STATUS_HCI_UART_LSB SOC_INT_STATUS_HCI_UART_LSB
#define INT_STATUS_HCI_UART_MASK SOC_INT_STATUS_HCI_UART_MASK
#define INT_STATUS_HCI_UART_GET(x) SOC_INT_STATUS_HCI_UART_GET(x)
#define INT_STATUS_HCI_UART_SET(x) SOC_INT_STATUS_HCI_UART_SET(x)
#define INT_STATUS_THERM_MSB SOC_INT_STATUS_THERM_MSB
#define INT_STATUS_THERM_LSB SOC_INT_STATUS_THERM_LSB
#define INT_STATUS_THERM_MASK SOC_INT_STATUS_THERM_MASK
#define INT_STATUS_THERM_GET(x) SOC_INT_STATUS_THERM_GET(x)
#define INT_STATUS_THERM_SET(x) SOC_INT_STATUS_THERM_SET(x)
#define INT_STATUS_EFUSE_OVERWRITE_MSB SOC_INT_STATUS_EFUSE_OVERWRITE_MSB
#define INT_STATUS_EFUSE_OVERWRITE_LSB SOC_INT_STATUS_EFUSE_OVERWRITE_LSB
#define INT_STATUS_EFUSE_OVERWRITE_MASK SOC_INT_STATUS_EFUSE_OVERWRITE_MASK
#define INT_STATUS_EFUSE_OVERWRITE_GET(x) SOC_INT_STATUS_EFUSE_OVERWRITE_GET(x)
#define INT_STATUS_EFUSE_OVERWRITE_SET(x) SOC_INT_STATUS_EFUSE_OVERWRITE_SET(x)
#define INT_STATUS_UART_MBOX_MSB SOC_INT_STATUS_UART_MBOX_MSB
#define INT_STATUS_UART_MBOX_LSB SOC_INT_STATUS_UART_MBOX_LSB
#define INT_STATUS_UART_MBOX_MASK SOC_INT_STATUS_UART_MBOX_MASK
#define INT_STATUS_UART_MBOX_GET(x) SOC_INT_STATUS_UART_MBOX_GET(x)
#define INT_STATUS_UART_MBOX_SET(x) SOC_INT_STATUS_UART_MBOX_SET(x)
#define INT_STATUS_GENERIC_MBOX_MSB SOC_INT_STATUS_GENERIC_MBOX_MSB
#define INT_STATUS_GENERIC_MBOX_LSB SOC_INT_STATUS_GENERIC_MBOX_LSB
#define INT_STATUS_GENERIC_MBOX_MASK SOC_INT_STATUS_GENERIC_MBOX_MASK
#define INT_STATUS_GENERIC_MBOX_GET(x) SOC_INT_STATUS_GENERIC_MBOX_GET(x)
#define INT_STATUS_GENERIC_MBOX_SET(x) SOC_INT_STATUS_GENERIC_MBOX_SET(x)
#define INT_STATUS_RDMA_MSB SOC_INT_STATUS_RDMA_MSB
#define INT_STATUS_RDMA_LSB SOC_INT_STATUS_RDMA_LSB
#define INT_STATUS_RDMA_MASK SOC_INT_STATUS_RDMA_MASK
#define INT_STATUS_RDMA_GET(x) SOC_INT_STATUS_RDMA_GET(x)
#define INT_STATUS_RDMA_SET(x) SOC_INT_STATUS_RDMA_SET(x)
#define INT_STATUS_BTCOEX_MSB SOC_INT_STATUS_BTCOEX_MSB
#define INT_STATUS_BTCOEX_LSB SOC_INT_STATUS_BTCOEX_LSB
#define INT_STATUS_BTCOEX_MASK SOC_INT_STATUS_BTCOEX_MASK
#define INT_STATUS_BTCOEX_GET(x) SOC_INT_STATUS_BTCOEX_GET(x)
#define INT_STATUS_BTCOEX_SET(x) SOC_INT_STATUS_BTCOEX_SET(x)
#define INT_STATUS_RTC_POWER_MSB SOC_INT_STATUS_RTC_POWER_MSB
#define INT_STATUS_RTC_POWER_LSB SOC_INT_STATUS_RTC_POWER_LSB
#define INT_STATUS_RTC_POWER_MASK SOC_INT_STATUS_RTC_POWER_MASK
#define INT_STATUS_RTC_POWER_GET(x) SOC_INT_STATUS_RTC_POWER_GET(x)
#define INT_STATUS_RTC_POWER_SET(x) SOC_INT_STATUS_RTC_POWER_SET(x)
#define INT_STATUS_MAC_MSB SOC_INT_STATUS_MAC_MSB
#define INT_STATUS_MAC_LSB SOC_INT_STATUS_MAC_LSB
#define INT_STATUS_MAC_MASK SOC_INT_STATUS_MAC_MASK
#define INT_STATUS_MAC_GET(x) SOC_INT_STATUS_MAC_GET(x)
#define INT_STATUS_MAC_SET(x) SOC_INT_STATUS_MAC_SET(x)
#define INT_STATUS_MAILBOX_MSB SOC_INT_STATUS_MAILBOX_MSB
#define INT_STATUS_MAILBOX_LSB SOC_INT_STATUS_MAILBOX_LSB
#define INT_STATUS_MAILBOX_MASK SOC_INT_STATUS_MAILBOX_MASK
#define INT_STATUS_MAILBOX_GET(x) SOC_INT_STATUS_MAILBOX_GET(x)
#define INT_STATUS_MAILBOX_SET(x) SOC_INT_STATUS_MAILBOX_SET(x)
#define INT_STATUS_RTC_ALARM_MSB SOC_INT_STATUS_RTC_ALARM_MSB
#define INT_STATUS_RTC_ALARM_LSB SOC_INT_STATUS_RTC_ALARM_LSB
#define INT_STATUS_RTC_ALARM_MASK SOC_INT_STATUS_RTC_ALARM_MASK
#define INT_STATUS_RTC_ALARM_GET(x) SOC_INT_STATUS_RTC_ALARM_GET(x)
#define INT_STATUS_RTC_ALARM_SET(x) SOC_INT_STATUS_RTC_ALARM_SET(x)
#define INT_STATUS_HF_TIMER_MSB SOC_INT_STATUS_HF_TIMER_MSB
#define INT_STATUS_HF_TIMER_LSB SOC_INT_STATUS_HF_TIMER_LSB
#define INT_STATUS_HF_TIMER_MASK SOC_INT_STATUS_HF_TIMER_MASK
#define INT_STATUS_HF_TIMER_GET(x) SOC_INT_STATUS_HF_TIMER_GET(x)
#define INT_STATUS_HF_TIMER_SET(x) SOC_INT_STATUS_HF_TIMER_SET(x)
#define INT_STATUS_LF_TIMER3_MSB SOC_INT_STATUS_LF_TIMER3_MSB
#define INT_STATUS_LF_TIMER3_LSB SOC_INT_STATUS_LF_TIMER3_LSB
#define INT_STATUS_LF_TIMER3_MASK SOC_INT_STATUS_LF_TIMER3_MASK
#define INT_STATUS_LF_TIMER3_GET(x) SOC_INT_STATUS_LF_TIMER3_GET(x)
#define INT_STATUS_LF_TIMER3_SET(x) SOC_INT_STATUS_LF_TIMER3_SET(x)
#define INT_STATUS_LF_TIMER2_MSB SOC_INT_STATUS_LF_TIMER2_MSB
#define INT_STATUS_LF_TIMER2_LSB SOC_INT_STATUS_LF_TIMER2_LSB
#define INT_STATUS_LF_TIMER2_MASK SOC_INT_STATUS_LF_TIMER2_MASK
#define INT_STATUS_LF_TIMER2_GET(x) SOC_INT_STATUS_LF_TIMER2_GET(x)
#define INT_STATUS_LF_TIMER2_SET(x) SOC_INT_STATUS_LF_TIMER2_SET(x)
#define INT_STATUS_LF_TIMER1_MSB SOC_INT_STATUS_LF_TIMER1_MSB
#define INT_STATUS_LF_TIMER1_LSB SOC_INT_STATUS_LF_TIMER1_LSB
#define INT_STATUS_LF_TIMER1_MASK SOC_INT_STATUS_LF_TIMER1_MASK
#define INT_STATUS_LF_TIMER1_GET(x) SOC_INT_STATUS_LF_TIMER1_GET(x)
#define INT_STATUS_LF_TIMER1_SET(x) SOC_INT_STATUS_LF_TIMER1_SET(x)
#define INT_STATUS_LF_TIMER0_MSB SOC_INT_STATUS_LF_TIMER0_MSB
#define INT_STATUS_LF_TIMER0_LSB SOC_INT_STATUS_LF_TIMER0_LSB
#define INT_STATUS_LF_TIMER0_MASK SOC_INT_STATUS_LF_TIMER0_MASK
#define INT_STATUS_LF_TIMER0_GET(x) SOC_INT_STATUS_LF_TIMER0_GET(x)
#define INT_STATUS_LF_TIMER0_SET(x) SOC_INT_STATUS_LF_TIMER0_SET(x)
#define INT_STATUS_KEYPAD_MSB SOC_INT_STATUS_KEYPAD_MSB
#define INT_STATUS_KEYPAD_LSB SOC_INT_STATUS_KEYPAD_LSB
#define INT_STATUS_KEYPAD_MASK SOC_INT_STATUS_KEYPAD_MASK
#define INT_STATUS_KEYPAD_GET(x) SOC_INT_STATUS_KEYPAD_GET(x)
#define INT_STATUS_KEYPAD_SET(x) SOC_INT_STATUS_KEYPAD_SET(x)
#define INT_STATUS_SI_MSB SOC_INT_STATUS_SI_MSB
#define INT_STATUS_SI_LSB SOC_INT_STATUS_SI_LSB
#define INT_STATUS_SI_MASK SOC_INT_STATUS_SI_MASK
#define INT_STATUS_SI_GET(x) SOC_INT_STATUS_SI_GET(x)
#define INT_STATUS_SI_SET(x) SOC_INT_STATUS_SI_SET(x)
#define INT_STATUS_GPIO_MSB SOC_INT_STATUS_GPIO_MSB
#define INT_STATUS_GPIO_LSB SOC_INT_STATUS_GPIO_LSB
#define INT_STATUS_GPIO_MASK SOC_INT_STATUS_GPIO_MASK
#define INT_STATUS_GPIO_GET(x) SOC_INT_STATUS_GPIO_GET(x)
#define INT_STATUS_GPIO_SET(x) SOC_INT_STATUS_GPIO_SET(x)
#define INT_STATUS_UART_MSB SOC_INT_STATUS_UART_MSB
#define INT_STATUS_UART_LSB SOC_INT_STATUS_UART_LSB
#define INT_STATUS_UART_MASK SOC_INT_STATUS_UART_MASK
#define INT_STATUS_UART_GET(x) SOC_INT_STATUS_UART_GET(x)
#define INT_STATUS_UART_SET(x) SOC_INT_STATUS_UART_SET(x)
#define INT_STATUS_ERROR_MSB SOC_INT_STATUS_ERROR_MSB
#define INT_STATUS_ERROR_LSB SOC_INT_STATUS_ERROR_LSB
#define INT_STATUS_ERROR_MASK SOC_INT_STATUS_ERROR_MASK
#define INT_STATUS_ERROR_GET(x) SOC_INT_STATUS_ERROR_GET(x)
#define INT_STATUS_ERROR_SET(x) SOC_INT_STATUS_ERROR_SET(x)
#define INT_STATUS_WDT_INT_MSB SOC_INT_STATUS_WDT_INT_MSB
#define INT_STATUS_WDT_INT_LSB SOC_INT_STATUS_WDT_INT_LSB
#define INT_STATUS_WDT_INT_MASK SOC_INT_STATUS_WDT_INT_MASK
#define INT_STATUS_WDT_INT_GET(x) SOC_INT_STATUS_WDT_INT_GET(x)
#define INT_STATUS_WDT_INT_SET(x) SOC_INT_STATUS_WDT_INT_SET(x)
#define LF_TIMER0_ADDRESS SOC_LF_TIMER0_ADDRESS
#define LF_TIMER0_OFFSET SOC_LF_TIMER0_OFFSET
#define LF_TIMER0_TARGET_MSB SOC_LF_TIMER0_TARGET_MSB
#define LF_TIMER0_TARGET_LSB SOC_LF_TIMER0_TARGET_LSB
#define LF_TIMER0_TARGET_MASK SOC_LF_TIMER0_TARGET_MASK
#define LF_TIMER0_TARGET_GET(x) SOC_LF_TIMER0_TARGET_GET(x)
#define LF_TIMER0_TARGET_SET(x) SOC_LF_TIMER0_TARGET_SET(x)
#define LF_TIMER_COUNT0_ADDRESS SOC_LF_TIMER_COUNT0_ADDRESS
#define LF_TIMER_COUNT0_OFFSET SOC_LF_TIMER_COUNT0_OFFSET
#define LF_TIMER_COUNT0_VALUE_MSB SOC_LF_TIMER_COUNT0_VALUE_MSB
#define LF_TIMER_COUNT0_VALUE_LSB SOC_LF_TIMER_COUNT0_VALUE_LSB
#define LF_TIMER_COUNT0_VALUE_MASK SOC_LF_TIMER_COUNT0_VALUE_MASK
#define LF_TIMER_COUNT0_VALUE_GET(x) SOC_LF_TIMER_COUNT0_VALUE_GET(x)
#define LF_TIMER_COUNT0_VALUE_SET(x) SOC_LF_TIMER_COUNT0_VALUE_SET(x)
#define LF_TIMER_CONTROL0_ADDRESS SOC_LF_TIMER_CONTROL0_ADDRESS
#define LF_TIMER_CONTROL0_OFFSET SOC_LF_TIMER_CONTROL0_OFFSET
#define LF_TIMER_CONTROL0_ENABLE_MSB SOC_LF_TIMER_CONTROL0_ENABLE_MSB
#define LF_TIMER_CONTROL0_ENABLE_LSB SOC_LF_TIMER_CONTROL0_ENABLE_LSB
#define LF_TIMER_CONTROL0_ENABLE_MASK SOC_LF_TIMER_CONTROL0_ENABLE_MASK
#define LF_TIMER_CONTROL0_ENABLE_GET(x) SOC_LF_TIMER_CONTROL0_ENABLE_GET(x)
#define LF_TIMER_CONTROL0_ENABLE_SET(x) SOC_LF_TIMER_CONTROL0_ENABLE_SET(x)
#define LF_TIMER_CONTROL0_AUTO_RESTART_MSB SOC_LF_TIMER_CONTROL0_AUTO_RESTART_MSB
#define LF_TIMER_CONTROL0_AUTO_RESTART_LSB SOC_LF_TIMER_CONTROL0_AUTO_RESTART_LSB
#define LF_TIMER_CONTROL0_AUTO_RESTART_MASK SOC_LF_TIMER_CONTROL0_AUTO_RESTART_MASK
#define LF_TIMER_CONTROL0_AUTO_RESTART_GET(x) SOC_LF_TIMER_CONTROL0_AUTO_RESTART_GET(x)
#define LF_TIMER_CONTROL0_AUTO_RESTART_SET(x) SOC_LF_TIMER_CONTROL0_AUTO_RESTART_SET(x)
#define LF_TIMER_CONTROL0_RESET_MSB SOC_LF_TIMER_CONTROL0_RESET_MSB
#define LF_TIMER_CONTROL0_RESET_LSB SOC_LF_TIMER_CONTROL0_RESET_LSB
#define LF_TIMER_CONTROL0_RESET_MASK SOC_LF_TIMER_CONTROL0_RESET_MASK
#define LF_TIMER_CONTROL0_RESET_GET(x) SOC_LF_TIMER_CONTROL0_RESET_GET(x)
#define LF_TIMER_CONTROL0_RESET_SET(x) SOC_LF_TIMER_CONTROL0_RESET_SET(x)
#define LF_TIMER_STATUS0_ADDRESS SOC_LF_TIMER_STATUS0_ADDRESS
#define LF_TIMER_STATUS0_OFFSET SOC_LF_TIMER_STATUS0_OFFSET
#define LF_TIMER_STATUS0_INTERRUPT_MSB SOC_LF_TIMER_STATUS0_INTERRUPT_MSB
#define LF_TIMER_STATUS0_INTERRUPT_LSB SOC_LF_TIMER_STATUS0_INTERRUPT_LSB
#define LF_TIMER_STATUS0_INTERRUPT_MASK SOC_LF_TIMER_STATUS0_INTERRUPT_MASK
#define LF_TIMER_STATUS0_INTERRUPT_GET(x) SOC_LF_TIMER_STATUS0_INTERRUPT_GET(x)
#define LF_TIMER_STATUS0_INTERRUPT_SET(x) SOC_LF_TIMER_STATUS0_INTERRUPT_SET(x)
#define LF_TIMER1_ADDRESS SOC_LF_TIMER1_ADDRESS
#define LF_TIMER1_OFFSET SOC_LF_TIMER1_OFFSET
#define LF_TIMER1_TARGET_MSB SOC_LF_TIMER1_TARGET_MSB
#define LF_TIMER1_TARGET_LSB SOC_LF_TIMER1_TARGET_LSB
#define LF_TIMER1_TARGET_MASK SOC_LF_TIMER1_TARGET_MASK
#define LF_TIMER1_TARGET_GET(x) SOC_LF_TIMER1_TARGET_GET(x)
#define LF_TIMER1_TARGET_SET(x) SOC_LF_TIMER1_TARGET_SET(x)
#define LF_TIMER_COUNT1_ADDRESS SOC_LF_TIMER_COUNT1_ADDRESS
#define LF_TIMER_COUNT1_OFFSET SOC_LF_TIMER_COUNT1_OFFSET
#define LF_TIMER_COUNT1_VALUE_MSB SOC_LF_TIMER_COUNT1_VALUE_MSB
#define LF_TIMER_COUNT1_VALUE_LSB SOC_LF_TIMER_COUNT1_VALUE_LSB
#define LF_TIMER_COUNT1_VALUE_MASK SOC_LF_TIMER_COUNT1_VALUE_MASK
#define LF_TIMER_COUNT1_VALUE_GET(x) SOC_LF_TIMER_COUNT1_VALUE_GET(x)
#define LF_TIMER_COUNT1_VALUE_SET(x) SOC_LF_TIMER_COUNT1_VALUE_SET(x)
#define LF_TIMER_CONTROL1_ADDRESS SOC_LF_TIMER_CONTROL1_ADDRESS
#define LF_TIMER_CONTROL1_OFFSET SOC_LF_TIMER_CONTROL1_OFFSET
#define LF_TIMER_CONTROL1_ENABLE_MSB SOC_LF_TIMER_CONTROL1_ENABLE_MSB
#define LF_TIMER_CONTROL1_ENABLE_LSB SOC_LF_TIMER_CONTROL1_ENABLE_LSB
#define LF_TIMER_CONTROL1_ENABLE_MASK SOC_LF_TIMER_CONTROL1_ENABLE_MASK
#define LF_TIMER_CONTROL1_ENABLE_GET(x) SOC_LF_TIMER_CONTROL1_ENABLE_GET(x)
#define LF_TIMER_CONTROL1_ENABLE_SET(x) SOC_LF_TIMER_CONTROL1_ENABLE_SET(x)
#define LF_TIMER_CONTROL1_AUTO_RESTART_MSB SOC_LF_TIMER_CONTROL1_AUTO_RESTART_MSB
#define LF_TIMER_CONTROL1_AUTO_RESTART_LSB SOC_LF_TIMER_CONTROL1_AUTO_RESTART_LSB
#define LF_TIMER_CONTROL1_AUTO_RESTART_MASK SOC_LF_TIMER_CONTROL1_AUTO_RESTART_MASK
#define LF_TIMER_CONTROL1_AUTO_RESTART_GET(x) SOC_LF_TIMER_CONTROL1_AUTO_RESTART_GET(x)
#define LF_TIMER_CONTROL1_AUTO_RESTART_SET(x) SOC_LF_TIMER_CONTROL1_AUTO_RESTART_SET(x)
#define LF_TIMER_CONTROL1_RESET_MSB SOC_LF_TIMER_CONTROL1_RESET_MSB
#define LF_TIMER_CONTROL1_RESET_LSB SOC_LF_TIMER_CONTROL1_RESET_LSB
#define LF_TIMER_CONTROL1_RESET_MASK SOC_LF_TIMER_CONTROL1_RESET_MASK
#define LF_TIMER_CONTROL1_RESET_GET(x) SOC_LF_TIMER_CONTROL1_RESET_GET(x)
#define LF_TIMER_CONTROL1_RESET_SET(x) SOC_LF_TIMER_CONTROL1_RESET_SET(x)
#define LF_TIMER_STATUS1_ADDRESS SOC_LF_TIMER_STATUS1_ADDRESS
#define LF_TIMER_STATUS1_OFFSET SOC_LF_TIMER_STATUS1_OFFSET
#define LF_TIMER_STATUS1_INTERRUPT_MSB SOC_LF_TIMER_STATUS1_INTERRUPT_MSB
#define LF_TIMER_STATUS1_INTERRUPT_LSB SOC_LF_TIMER_STATUS1_INTERRUPT_LSB
#define LF_TIMER_STATUS1_INTERRUPT_MASK SOC_LF_TIMER_STATUS1_INTERRUPT_MASK
#define LF_TIMER_STATUS1_INTERRUPT_GET(x) SOC_LF_TIMER_STATUS1_INTERRUPT_GET(x)
#define LF_TIMER_STATUS1_INTERRUPT_SET(x) SOC_LF_TIMER_STATUS1_INTERRUPT_SET(x)
#define LF_TIMER2_ADDRESS SOC_LF_TIMER2_ADDRESS
#define LF_TIMER2_OFFSET SOC_LF_TIMER2_OFFSET
#define LF_TIMER2_TARGET_MSB SOC_LF_TIMER2_TARGET_MSB
#define LF_TIMER2_TARGET_LSB SOC_LF_TIMER2_TARGET_LSB
#define LF_TIMER2_TARGET_MASK SOC_LF_TIMER2_TARGET_MASK
#define LF_TIMER2_TARGET_GET(x) SOC_LF_TIMER2_TARGET_GET(x)
#define LF_TIMER2_TARGET_SET(x) SOC_LF_TIMER2_TARGET_SET(x)
#define LF_TIMER_COUNT2_ADDRESS SOC_LF_TIMER_COUNT2_ADDRESS
#define LF_TIMER_COUNT2_OFFSET SOC_LF_TIMER_COUNT2_OFFSET
#define LF_TIMER_COUNT2_VALUE_MSB SOC_LF_TIMER_COUNT2_VALUE_MSB
#define LF_TIMER_COUNT2_VALUE_LSB SOC_LF_TIMER_COUNT2_VALUE_LSB
#define LF_TIMER_COUNT2_VALUE_MASK SOC_LF_TIMER_COUNT2_VALUE_MASK
#define LF_TIMER_COUNT2_VALUE_GET(x) SOC_LF_TIMER_COUNT2_VALUE_GET(x)
#define LF_TIMER_COUNT2_VALUE_SET(x) SOC_LF_TIMER_COUNT2_VALUE_SET(x)
#define LF_TIMER_CONTROL2_ADDRESS SOC_LF_TIMER_CONTROL2_ADDRESS
#define LF_TIMER_CONTROL2_OFFSET SOC_LF_TIMER_CONTROL2_OFFSET
#define LF_TIMER_CONTROL2_ENABLE_MSB SOC_LF_TIMER_CONTROL2_ENABLE_MSB
#define LF_TIMER_CONTROL2_ENABLE_LSB SOC_LF_TIMER_CONTROL2_ENABLE_LSB
#define LF_TIMER_CONTROL2_ENABLE_MASK SOC_LF_TIMER_CONTROL2_ENABLE_MASK
#define LF_TIMER_CONTROL2_ENABLE_GET(x) SOC_LF_TIMER_CONTROL2_ENABLE_GET(x)
#define LF_TIMER_CONTROL2_ENABLE_SET(x) SOC_LF_TIMER_CONTROL2_ENABLE_SET(x)
#define LF_TIMER_CONTROL2_AUTO_RESTART_MSB SOC_LF_TIMER_CONTROL2_AUTO_RESTART_MSB
#define LF_TIMER_CONTROL2_AUTO_RESTART_LSB SOC_LF_TIMER_CONTROL2_AUTO_RESTART_LSB
#define LF_TIMER_CONTROL2_AUTO_RESTART_MASK SOC_LF_TIMER_CONTROL2_AUTO_RESTART_MASK
#define LF_TIMER_CONTROL2_AUTO_RESTART_GET(x) SOC_LF_TIMER_CONTROL2_AUTO_RESTART_GET(x)
#define LF_TIMER_CONTROL2_AUTO_RESTART_SET(x) SOC_LF_TIMER_CONTROL2_AUTO_RESTART_SET(x)
#define LF_TIMER_CONTROL2_RESET_MSB SOC_LF_TIMER_CONTROL2_RESET_MSB
#define LF_TIMER_CONTROL2_RESET_LSB SOC_LF_TIMER_CONTROL2_RESET_LSB
#define LF_TIMER_CONTROL2_RESET_MASK SOC_LF_TIMER_CONTROL2_RESET_MASK
#define LF_TIMER_CONTROL2_RESET_GET(x) SOC_LF_TIMER_CONTROL2_RESET_GET(x)
#define LF_TIMER_CONTROL2_RESET_SET(x) SOC_LF_TIMER_CONTROL2_RESET_SET(x)
#define LF_TIMER_STATUS2_ADDRESS SOC_LF_TIMER_STATUS2_ADDRESS
#define LF_TIMER_STATUS2_OFFSET SOC_LF_TIMER_STATUS2_OFFSET
#define LF_TIMER_STATUS2_INTERRUPT_MSB SOC_LF_TIMER_STATUS2_INTERRUPT_MSB
#define LF_TIMER_STATUS2_INTERRUPT_LSB SOC_LF_TIMER_STATUS2_INTERRUPT_LSB
#define LF_TIMER_STATUS2_INTERRUPT_MASK SOC_LF_TIMER_STATUS2_INTERRUPT_MASK
#define LF_TIMER_STATUS2_INTERRUPT_GET(x) SOC_LF_TIMER_STATUS2_INTERRUPT_GET(x)
#define LF_TIMER_STATUS2_INTERRUPT_SET(x) SOC_LF_TIMER_STATUS2_INTERRUPT_SET(x)
#define LF_TIMER3_ADDRESS SOC_LF_TIMER3_ADDRESS
#define LF_TIMER3_OFFSET SOC_LF_TIMER3_OFFSET
#define LF_TIMER3_TARGET_MSB SOC_LF_TIMER3_TARGET_MSB
#define LF_TIMER3_TARGET_LSB SOC_LF_TIMER3_TARGET_LSB
#define LF_TIMER3_TARGET_MASK SOC_LF_TIMER3_TARGET_MASK
#define LF_TIMER3_TARGET_GET(x) SOC_LF_TIMER3_TARGET_GET(x)
#define LF_TIMER3_TARGET_SET(x) SOC_LF_TIMER3_TARGET_SET(x)
#define LF_TIMER_COUNT3_ADDRESS SOC_LF_TIMER_COUNT3_ADDRESS
#define LF_TIMER_COUNT3_OFFSET SOC_LF_TIMER_COUNT3_OFFSET
#define LF_TIMER_COUNT3_VALUE_MSB SOC_LF_TIMER_COUNT3_VALUE_MSB
#define LF_TIMER_COUNT3_VALUE_LSB SOC_LF_TIMER_COUNT3_VALUE_LSB
#define LF_TIMER_COUNT3_VALUE_MASK SOC_LF_TIMER_COUNT3_VALUE_MASK
#define LF_TIMER_COUNT3_VALUE_GET(x) SOC_LF_TIMER_COUNT3_VALUE_GET(x)
#define LF_TIMER_COUNT3_VALUE_SET(x) SOC_LF_TIMER_COUNT3_VALUE_SET(x)
#define LF_TIMER_CONTROL3_ADDRESS SOC_LF_TIMER_CONTROL3_ADDRESS
#define LF_TIMER_CONTROL3_OFFSET SOC_LF_TIMER_CONTROL3_OFFSET
#define LF_TIMER_CONTROL3_ENABLE_MSB SOC_LF_TIMER_CONTROL3_ENABLE_MSB
#define LF_TIMER_CONTROL3_ENABLE_LSB SOC_LF_TIMER_CONTROL3_ENABLE_LSB
#define LF_TIMER_CONTROL3_ENABLE_MASK SOC_LF_TIMER_CONTROL3_ENABLE_MASK
#define LF_TIMER_CONTROL3_ENABLE_GET(x) SOC_LF_TIMER_CONTROL3_ENABLE_GET(x)
#define LF_TIMER_CONTROL3_ENABLE_SET(x) SOC_LF_TIMER_CONTROL3_ENABLE_SET(x)
#define LF_TIMER_CONTROL3_AUTO_RESTART_MSB SOC_LF_TIMER_CONTROL3_AUTO_RESTART_MSB
#define LF_TIMER_CONTROL3_AUTO_RESTART_LSB SOC_LF_TIMER_CONTROL3_AUTO_RESTART_LSB
#define LF_TIMER_CONTROL3_AUTO_RESTART_MASK SOC_LF_TIMER_CONTROL3_AUTO_RESTART_MASK
#define LF_TIMER_CONTROL3_AUTO_RESTART_GET(x) SOC_LF_TIMER_CONTROL3_AUTO_RESTART_GET(x)
#define LF_TIMER_CONTROL3_AUTO_RESTART_SET(x) SOC_LF_TIMER_CONTROL3_AUTO_RESTART_SET(x)
#define LF_TIMER_CONTROL3_RESET_MSB SOC_LF_TIMER_CONTROL3_RESET_MSB
#define LF_TIMER_CONTROL3_RESET_LSB SOC_LF_TIMER_CONTROL3_RESET_LSB
#define LF_TIMER_CONTROL3_RESET_MASK SOC_LF_TIMER_CONTROL3_RESET_MASK
#define LF_TIMER_CONTROL3_RESET_GET(x) SOC_LF_TIMER_CONTROL3_RESET_GET(x)
#define LF_TIMER_CONTROL3_RESET_SET(x) SOC_LF_TIMER_CONTROL3_RESET_SET(x)
#define LF_TIMER_STATUS3_ADDRESS SOC_LF_TIMER_STATUS3_ADDRESS
#define LF_TIMER_STATUS3_OFFSET SOC_LF_TIMER_STATUS3_OFFSET
#define LF_TIMER_STATUS3_INTERRUPT_MSB SOC_LF_TIMER_STATUS3_INTERRUPT_MSB
#define LF_TIMER_STATUS3_INTERRUPT_LSB SOC_LF_TIMER_STATUS3_INTERRUPT_LSB
#define LF_TIMER_STATUS3_INTERRUPT_MASK SOC_LF_TIMER_STATUS3_INTERRUPT_MASK
#define LF_TIMER_STATUS3_INTERRUPT_GET(x) SOC_LF_TIMER_STATUS3_INTERRUPT_GET(x)
#define LF_TIMER_STATUS3_INTERRUPT_SET(x) SOC_LF_TIMER_STATUS3_INTERRUPT_SET(x)
#define HF_TIMER_ADDRESS SOC_HF_TIMER_ADDRESS
#define HF_TIMER_OFFSET SOC_HF_TIMER_OFFSET
#define HF_TIMER_TARGET_MSB SOC_HF_TIMER_TARGET_MSB
#define HF_TIMER_TARGET_LSB SOC_HF_TIMER_TARGET_LSB
#define HF_TIMER_TARGET_MASK SOC_HF_TIMER_TARGET_MASK
#define HF_TIMER_TARGET_GET(x) SOC_HF_TIMER_TARGET_GET(x)
#define HF_TIMER_TARGET_SET(x) SOC_HF_TIMER_TARGET_SET(x)
#define HF_TIMER_COUNT_ADDRESS SOC_HF_TIMER_COUNT_ADDRESS
#define HF_TIMER_COUNT_OFFSET SOC_HF_TIMER_COUNT_OFFSET
#define HF_TIMER_COUNT_VALUE_MSB SOC_HF_TIMER_COUNT_VALUE_MSB
#define HF_TIMER_COUNT_VALUE_LSB SOC_HF_TIMER_COUNT_VALUE_LSB
#define HF_TIMER_COUNT_VALUE_MASK SOC_HF_TIMER_COUNT_VALUE_MASK
#define HF_TIMER_COUNT_VALUE_GET(x) SOC_HF_TIMER_COUNT_VALUE_GET(x)
#define HF_TIMER_COUNT_VALUE_SET(x) SOC_HF_TIMER_COUNT_VALUE_SET(x)
#define HF_LF_COUNT_ADDRESS SOC_HF_LF_COUNT_ADDRESS
#define HF_LF_COUNT_OFFSET SOC_HF_LF_COUNT_OFFSET
#define HF_LF_COUNT_VALUE_MSB SOC_HF_LF_COUNT_VALUE_MSB
#define HF_LF_COUNT_VALUE_LSB SOC_HF_LF_COUNT_VALUE_LSB
#define HF_LF_COUNT_VALUE_MASK SOC_HF_LF_COUNT_VALUE_MASK
#define HF_LF_COUNT_VALUE_GET(x) SOC_HF_LF_COUNT_VALUE_GET(x)
#define HF_LF_COUNT_VALUE_SET(x) SOC_HF_LF_COUNT_VALUE_SET(x)
#define HF_TIMER_CONTROL_ADDRESS SOC_HF_TIMER_CONTROL_ADDRESS
#define HF_TIMER_CONTROL_OFFSET SOC_HF_TIMER_CONTROL_OFFSET
#define HF_TIMER_CONTROL_ENABLE_MSB SOC_HF_TIMER_CONTROL_ENABLE_MSB
#define HF_TIMER_CONTROL_ENABLE_LSB SOC_HF_TIMER_CONTROL_ENABLE_LSB
#define HF_TIMER_CONTROL_ENABLE_MASK SOC_HF_TIMER_CONTROL_ENABLE_MASK
#define HF_TIMER_CONTROL_ENABLE_GET(x) SOC_HF_TIMER_CONTROL_ENABLE_GET(x)
#define HF_TIMER_CONTROL_ENABLE_SET(x) SOC_HF_TIMER_CONTROL_ENABLE_SET(x)
#define HF_TIMER_CONTROL_ON_MSB SOC_HF_TIMER_CONTROL_ON_MSB
#define HF_TIMER_CONTROL_ON_LSB SOC_HF_TIMER_CONTROL_ON_LSB
#define HF_TIMER_CONTROL_ON_MASK SOC_HF_TIMER_CONTROL_ON_MASK
#define HF_TIMER_CONTROL_ON_GET(x) SOC_HF_TIMER_CONTROL_ON_GET(x)
#define HF_TIMER_CONTROL_ON_SET(x) SOC_HF_TIMER_CONTROL_ON_SET(x)
#define HF_TIMER_CONTROL_AUTO_RESTART_MSB SOC_HF_TIMER_CONTROL_AUTO_RESTART_MSB
#define HF_TIMER_CONTROL_AUTO_RESTART_LSB SOC_HF_TIMER_CONTROL_AUTO_RESTART_LSB
#define HF_TIMER_CONTROL_AUTO_RESTART_MASK SOC_HF_TIMER_CONTROL_AUTO_RESTART_MASK
#define HF_TIMER_CONTROL_AUTO_RESTART_GET(x) SOC_HF_TIMER_CONTROL_AUTO_RESTART_GET(x)
#define HF_TIMER_CONTROL_AUTO_RESTART_SET(x) SOC_HF_TIMER_CONTROL_AUTO_RESTART_SET(x)
#define HF_TIMER_CONTROL_RESET_MSB SOC_HF_TIMER_CONTROL_RESET_MSB
#define HF_TIMER_CONTROL_RESET_LSB SOC_HF_TIMER_CONTROL_RESET_LSB
#define HF_TIMER_CONTROL_RESET_MASK SOC_HF_TIMER_CONTROL_RESET_MASK
#define HF_TIMER_CONTROL_RESET_GET(x) SOC_HF_TIMER_CONTROL_RESET_GET(x)
#define HF_TIMER_CONTROL_RESET_SET(x) SOC_HF_TIMER_CONTROL_RESET_SET(x)
#define HF_TIMER_STATUS_ADDRESS SOC_HF_TIMER_STATUS_ADDRESS
#define HF_TIMER_STATUS_OFFSET SOC_HF_TIMER_STATUS_OFFSET
#define HF_TIMER_STATUS_INTERRUPT_MSB SOC_HF_TIMER_STATUS_INTERRUPT_MSB
#define HF_TIMER_STATUS_INTERRUPT_LSB SOC_HF_TIMER_STATUS_INTERRUPT_LSB
#define HF_TIMER_STATUS_INTERRUPT_MASK SOC_HF_TIMER_STATUS_INTERRUPT_MASK
#define HF_TIMER_STATUS_INTERRUPT_GET(x) SOC_HF_TIMER_STATUS_INTERRUPT_GET(x)
#define HF_TIMER_STATUS_INTERRUPT_SET(x) SOC_HF_TIMER_STATUS_INTERRUPT_SET(x)
#define RTC_CONTROL_ADDRESS SOC_RTC_CONTROL_ADDRESS
#define RTC_CONTROL_OFFSET SOC_RTC_CONTROL_OFFSET
#define RTC_CONTROL_ENABLE_MSB SOC_RTC_CONTROL_ENABLE_MSB
#define RTC_CONTROL_ENABLE_LSB SOC_RTC_CONTROL_ENABLE_LSB
#define RTC_CONTROL_ENABLE_MASK SOC_RTC_CONTROL_ENABLE_MASK
#define RTC_CONTROL_ENABLE_GET(x) SOC_RTC_CONTROL_ENABLE_GET(x)
#define RTC_CONTROL_ENABLE_SET(x) SOC_RTC_CONTROL_ENABLE_SET(x)
#define RTC_CONTROL_LOAD_RTC_MSB SOC_RTC_CONTROL_LOAD_RTC_MSB
#define RTC_CONTROL_LOAD_RTC_LSB SOC_RTC_CONTROL_LOAD_RTC_LSB
#define RTC_CONTROL_LOAD_RTC_MASK SOC_RTC_CONTROL_LOAD_RTC_MASK
#define RTC_CONTROL_LOAD_RTC_GET(x) SOC_RTC_CONTROL_LOAD_RTC_GET(x)
#define RTC_CONTROL_LOAD_RTC_SET(x) SOC_RTC_CONTROL_LOAD_RTC_SET(x)
#define RTC_CONTROL_LOAD_ALARM_MSB SOC_RTC_CONTROL_LOAD_ALARM_MSB
#define RTC_CONTROL_LOAD_ALARM_LSB SOC_RTC_CONTROL_LOAD_ALARM_LSB
#define RTC_CONTROL_LOAD_ALARM_MASK SOC_RTC_CONTROL_LOAD_ALARM_MASK
#define RTC_CONTROL_LOAD_ALARM_GET(x) SOC_RTC_CONTROL_LOAD_ALARM_GET(x)
#define RTC_CONTROL_LOAD_ALARM_SET(x) SOC_RTC_CONTROL_LOAD_ALARM_SET(x)
#define RTC_TIME_ADDRESS SOC_RTC_TIME_ADDRESS
#define RTC_TIME_OFFSET SOC_RTC_TIME_OFFSET
#define RTC_TIME_WEEK_DAY_MSB SOC_RTC_TIME_WEEK_DAY_MSB
#define RTC_TIME_WEEK_DAY_LSB SOC_RTC_TIME_WEEK_DAY_LSB
#define RTC_TIME_WEEK_DAY_MASK SOC_RTC_TIME_WEEK_DAY_MASK
#define RTC_TIME_WEEK_DAY_GET(x) SOC_RTC_TIME_WEEK_DAY_GET(x)
#define RTC_TIME_WEEK_DAY_SET(x) SOC_RTC_TIME_WEEK_DAY_SET(x)
#define RTC_TIME_HOUR_MSB SOC_RTC_TIME_HOUR_MSB
#define RTC_TIME_HOUR_LSB SOC_RTC_TIME_HOUR_LSB
#define RTC_TIME_HOUR_MASK SOC_RTC_TIME_HOUR_MASK
#define RTC_TIME_HOUR_GET(x) SOC_RTC_TIME_HOUR_GET(x)
#define RTC_TIME_HOUR_SET(x) SOC_RTC_TIME_HOUR_SET(x)
#define RTC_TIME_MINUTE_MSB SOC_RTC_TIME_MINUTE_MSB
#define RTC_TIME_MINUTE_LSB SOC_RTC_TIME_MINUTE_LSB
#define RTC_TIME_MINUTE_MASK SOC_RTC_TIME_MINUTE_MASK
#define RTC_TIME_MINUTE_GET(x) SOC_RTC_TIME_MINUTE_GET(x)
#define RTC_TIME_MINUTE_SET(x) SOC_RTC_TIME_MINUTE_SET(x)
#define RTC_TIME_SECOND_MSB SOC_RTC_TIME_SECOND_MSB
#define RTC_TIME_SECOND_LSB SOC_RTC_TIME_SECOND_LSB
#define RTC_TIME_SECOND_MASK SOC_RTC_TIME_SECOND_MASK
#define RTC_TIME_SECOND_GET(x) SOC_RTC_TIME_SECOND_GET(x)
#define RTC_TIME_SECOND_SET(x) SOC_RTC_TIME_SECOND_SET(x)
#define RTC_DATE_ADDRESS SOC_RTC_DATE_ADDRESS
#define RTC_DATE_OFFSET SOC_RTC_DATE_OFFSET
#define RTC_DATE_YEAR_MSB SOC_RTC_DATE_YEAR_MSB
#define RTC_DATE_YEAR_LSB SOC_RTC_DATE_YEAR_LSB
#define RTC_DATE_YEAR_MASK SOC_RTC_DATE_YEAR_MASK
#define RTC_DATE_YEAR_GET(x) SOC_RTC_DATE_YEAR_GET(x)
#define RTC_DATE_YEAR_SET(x) SOC_RTC_DATE_YEAR_SET(x)
#define RTC_DATE_MONTH_MSB SOC_RTC_DATE_MONTH_MSB
#define RTC_DATE_MONTH_LSB SOC_RTC_DATE_MONTH_LSB
#define RTC_DATE_MONTH_MASK SOC_RTC_DATE_MONTH_MASK
#define RTC_DATE_MONTH_GET(x) SOC_RTC_DATE_MONTH_GET(x)
#define RTC_DATE_MONTH_SET(x) SOC_RTC_DATE_MONTH_SET(x)
#define RTC_DATE_MONTH_DAY_MSB SOC_RTC_DATE_MONTH_DAY_MSB
#define RTC_DATE_MONTH_DAY_LSB SOC_RTC_DATE_MONTH_DAY_LSB
#define RTC_DATE_MONTH_DAY_MASK SOC_RTC_DATE_MONTH_DAY_MASK
#define RTC_DATE_MONTH_DAY_GET(x) SOC_RTC_DATE_MONTH_DAY_GET(x)
#define RTC_DATE_MONTH_DAY_SET(x) SOC_RTC_DATE_MONTH_DAY_SET(x)
#define RTC_SET_TIME_ADDRESS SOC_RTC_SET_TIME_ADDRESS
#define RTC_SET_TIME_OFFSET SOC_RTC_SET_TIME_OFFSET
#define RTC_SET_TIME_WEEK_DAY_MSB SOC_RTC_SET_TIME_WEEK_DAY_MSB
#define RTC_SET_TIME_WEEK_DAY_LSB SOC_RTC_SET_TIME_WEEK_DAY_LSB
#define RTC_SET_TIME_WEEK_DAY_MASK SOC_RTC_SET_TIME_WEEK_DAY_MASK
#define RTC_SET_TIME_WEEK_DAY_GET(x) SOC_RTC_SET_TIME_WEEK_DAY_GET(x)
#define RTC_SET_TIME_WEEK_DAY_SET(x) SOC_RTC_SET_TIME_WEEK_DAY_SET(x)
#define RTC_SET_TIME_HOUR_MSB SOC_RTC_SET_TIME_HOUR_MSB
#define RTC_SET_TIME_HOUR_LSB SOC_RTC_SET_TIME_HOUR_LSB
#define RTC_SET_TIME_HOUR_MASK SOC_RTC_SET_TIME_HOUR_MASK
#define RTC_SET_TIME_HOUR_GET(x) SOC_RTC_SET_TIME_HOUR_GET(x)
#define RTC_SET_TIME_HOUR_SET(x) SOC_RTC_SET_TIME_HOUR_SET(x)
#define RTC_SET_TIME_MINUTE_MSB SOC_RTC_SET_TIME_MINUTE_MSB
#define RTC_SET_TIME_MINUTE_LSB SOC_RTC_SET_TIME_MINUTE_LSB
#define RTC_SET_TIME_MINUTE_MASK SOC_RTC_SET_TIME_MINUTE_MASK
#define RTC_SET_TIME_MINUTE_GET(x) SOC_RTC_SET_TIME_MINUTE_GET(x)
#define RTC_SET_TIME_MINUTE_SET(x) SOC_RTC_SET_TIME_MINUTE_SET(x)
#define RTC_SET_TIME_SECOND_MSB SOC_RTC_SET_TIME_SECOND_MSB
#define RTC_SET_TIME_SECOND_LSB SOC_RTC_SET_TIME_SECOND_LSB
#define RTC_SET_TIME_SECOND_MASK SOC_RTC_SET_TIME_SECOND_MASK
#define RTC_SET_TIME_SECOND_GET(x) SOC_RTC_SET_TIME_SECOND_GET(x)
#define RTC_SET_TIME_SECOND_SET(x) SOC_RTC_SET_TIME_SECOND_SET(x)
#define RTC_SET_DATE_ADDRESS SOC_RTC_SET_DATE_ADDRESS
#define RTC_SET_DATE_OFFSET SOC_RTC_SET_DATE_OFFSET
#define RTC_SET_DATE_YEAR_MSB SOC_RTC_SET_DATE_YEAR_MSB
#define RTC_SET_DATE_YEAR_LSB SOC_RTC_SET_DATE_YEAR_LSB
#define RTC_SET_DATE_YEAR_MASK SOC_RTC_SET_DATE_YEAR_MASK
#define RTC_SET_DATE_YEAR_GET(x) SOC_RTC_SET_DATE_YEAR_GET(x)
#define RTC_SET_DATE_YEAR_SET(x) SOC_RTC_SET_DATE_YEAR_SET(x)
#define RTC_SET_DATE_MONTH_MSB SOC_RTC_SET_DATE_MONTH_MSB
#define RTC_SET_DATE_MONTH_LSB SOC_RTC_SET_DATE_MONTH_LSB
#define RTC_SET_DATE_MONTH_MASK SOC_RTC_SET_DATE_MONTH_MASK
#define RTC_SET_DATE_MONTH_GET(x) SOC_RTC_SET_DATE_MONTH_GET(x)
#define RTC_SET_DATE_MONTH_SET(x) SOC_RTC_SET_DATE_MONTH_SET(x)
#define RTC_SET_DATE_MONTH_DAY_MSB SOC_RTC_SET_DATE_MONTH_DAY_MSB
#define RTC_SET_DATE_MONTH_DAY_LSB SOC_RTC_SET_DATE_MONTH_DAY_LSB
#define RTC_SET_DATE_MONTH_DAY_MASK SOC_RTC_SET_DATE_MONTH_DAY_MASK
#define RTC_SET_DATE_MONTH_DAY_GET(x) SOC_RTC_SET_DATE_MONTH_DAY_GET(x)
#define RTC_SET_DATE_MONTH_DAY_SET(x) SOC_RTC_SET_DATE_MONTH_DAY_SET(x)
#define RTC_SET_ALARM_ADDRESS SOC_RTC_SET_ALARM_ADDRESS
#define RTC_SET_ALARM_OFFSET SOC_RTC_SET_ALARM_OFFSET
#define RTC_SET_ALARM_HOUR_MSB SOC_RTC_SET_ALARM_HOUR_MSB
#define RTC_SET_ALARM_HOUR_LSB SOC_RTC_SET_ALARM_HOUR_LSB
#define RTC_SET_ALARM_HOUR_MASK SOC_RTC_SET_ALARM_HOUR_MASK
#define RTC_SET_ALARM_HOUR_GET(x) SOC_RTC_SET_ALARM_HOUR_GET(x)
#define RTC_SET_ALARM_HOUR_SET(x) SOC_RTC_SET_ALARM_HOUR_SET(x)
#define RTC_SET_ALARM_MINUTE_MSB SOC_RTC_SET_ALARM_MINUTE_MSB
#define RTC_SET_ALARM_MINUTE_LSB SOC_RTC_SET_ALARM_MINUTE_LSB
#define RTC_SET_ALARM_MINUTE_MASK SOC_RTC_SET_ALARM_MINUTE_MASK
#define RTC_SET_ALARM_MINUTE_GET(x) SOC_RTC_SET_ALARM_MINUTE_GET(x)
#define RTC_SET_ALARM_MINUTE_SET(x) SOC_RTC_SET_ALARM_MINUTE_SET(x)
#define RTC_SET_ALARM_SECOND_MSB SOC_RTC_SET_ALARM_SECOND_MSB
#define RTC_SET_ALARM_SECOND_LSB SOC_RTC_SET_ALARM_SECOND_LSB
#define RTC_SET_ALARM_SECOND_MASK SOC_RTC_SET_ALARM_SECOND_MASK
#define RTC_SET_ALARM_SECOND_GET(x) SOC_RTC_SET_ALARM_SECOND_GET(x)
#define RTC_SET_ALARM_SECOND_SET(x) SOC_RTC_SET_ALARM_SECOND_SET(x)
#define RTC_CONFIG_ADDRESS SOC_RTC_CONFIG_ADDRESS
#define RTC_CONFIG_OFFSET SOC_RTC_CONFIG_OFFSET
#define RTC_CONFIG_BCD_MSB SOC_RTC_CONFIG_BCD_MSB
#define RTC_CONFIG_BCD_LSB SOC_RTC_CONFIG_BCD_LSB
#define RTC_CONFIG_BCD_MASK SOC_RTC_CONFIG_BCD_MASK
#define RTC_CONFIG_BCD_GET(x) SOC_RTC_CONFIG_BCD_GET(x)
#define RTC_CONFIG_BCD_SET(x) SOC_RTC_CONFIG_BCD_SET(x)
#define RTC_CONFIG_TWELVE_HOUR_MSB SOC_RTC_CONFIG_TWELVE_HOUR_MSB
#define RTC_CONFIG_TWELVE_HOUR_LSB SOC_RTC_CONFIG_TWELVE_HOUR_LSB
#define RTC_CONFIG_TWELVE_HOUR_MASK SOC_RTC_CONFIG_TWELVE_HOUR_MASK
#define RTC_CONFIG_TWELVE_HOUR_GET(x) SOC_RTC_CONFIG_TWELVE_HOUR_GET(x)
#define RTC_CONFIG_TWELVE_HOUR_SET(x) SOC_RTC_CONFIG_TWELVE_HOUR_SET(x)
#define RTC_CONFIG_DSE_MSB SOC_RTC_CONFIG_DSE_MSB
#define RTC_CONFIG_DSE_LSB SOC_RTC_CONFIG_DSE_LSB
#define RTC_CONFIG_DSE_MASK SOC_RTC_CONFIG_DSE_MASK
#define RTC_CONFIG_DSE_GET(x) SOC_RTC_CONFIG_DSE_GET(x)
#define RTC_CONFIG_DSE_SET(x) SOC_RTC_CONFIG_DSE_SET(x)
#define RTC_ALARM_STATUS_ADDRESS SOC_RTC_ALARM_STATUS_ADDRESS
#define RTC_ALARM_STATUS_OFFSET SOC_RTC_ALARM_STATUS_OFFSET
#define RTC_ALARM_STATUS_ENABLE_MSB SOC_RTC_ALARM_STATUS_ENABLE_MSB
#define RTC_ALARM_STATUS_ENABLE_LSB SOC_RTC_ALARM_STATUS_ENABLE_LSB
#define RTC_ALARM_STATUS_ENABLE_MASK SOC_RTC_ALARM_STATUS_ENABLE_MASK
#define RTC_ALARM_STATUS_ENABLE_GET(x) SOC_RTC_ALARM_STATUS_ENABLE_GET(x)
#define RTC_ALARM_STATUS_ENABLE_SET(x) SOC_RTC_ALARM_STATUS_ENABLE_SET(x)
#define RTC_ALARM_STATUS_INTERRUPT_MSB SOC_RTC_ALARM_STATUS_INTERRUPT_MSB
#define RTC_ALARM_STATUS_INTERRUPT_LSB SOC_RTC_ALARM_STATUS_INTERRUPT_LSB
#define RTC_ALARM_STATUS_INTERRUPT_MASK SOC_RTC_ALARM_STATUS_INTERRUPT_MASK
#define RTC_ALARM_STATUS_INTERRUPT_GET(x) SOC_RTC_ALARM_STATUS_INTERRUPT_GET(x)
#define RTC_ALARM_STATUS_INTERRUPT_SET(x) SOC_RTC_ALARM_STATUS_INTERRUPT_SET(x)
#define UART_WAKEUP_ADDRESS SOC_UART_WAKEUP_ADDRESS
#define UART_WAKEUP_OFFSET SOC_UART_WAKEUP_OFFSET
#define UART_WAKEUP_ENABLE_MSB SOC_UART_WAKEUP_ENABLE_MSB
#define UART_WAKEUP_ENABLE_LSB SOC_UART_WAKEUP_ENABLE_LSB
#define UART_WAKEUP_ENABLE_MASK SOC_UART_WAKEUP_ENABLE_MASK
#define UART_WAKEUP_ENABLE_GET(x) SOC_UART_WAKEUP_ENABLE_GET(x)
#define UART_WAKEUP_ENABLE_SET(x) SOC_UART_WAKEUP_ENABLE_SET(x)
#define RESET_CAUSE_ADDRESS SOC_RESET_CAUSE_ADDRESS
#define RESET_CAUSE_OFFSET SOC_RESET_CAUSE_OFFSET
#define RESET_CAUSE_LAST_MSB SOC_RESET_CAUSE_LAST_MSB
#define RESET_CAUSE_LAST_LSB SOC_RESET_CAUSE_LAST_LSB
#define RESET_CAUSE_LAST_MASK SOC_RESET_CAUSE_LAST_MASK
#define RESET_CAUSE_LAST_GET(x) SOC_RESET_CAUSE_LAST_GET(x)
#define RESET_CAUSE_LAST_SET(x) SOC_RESET_CAUSE_LAST_SET(x)
#define SYSTEM_SLEEP_ADDRESS SOC_SYSTEM_SLEEP_ADDRESS
#define SYSTEM_SLEEP_OFFSET SOC_SYSTEM_SLEEP_OFFSET
#define SYSTEM_SLEEP_MCI_MSB SOC_SYSTEM_SLEEP_MCI_MSB
#define SYSTEM_SLEEP_MCI_LSB SOC_SYSTEM_SLEEP_MCI_LSB
#define SYSTEM_SLEEP_MCI_MASK SOC_SYSTEM_SLEEP_MCI_MASK
#define SYSTEM_SLEEP_MCI_GET(x) SOC_SYSTEM_SLEEP_MCI_GET(x)
#define SYSTEM_SLEEP_MCI_SET(x) SOC_SYSTEM_SLEEP_MCI_SET(x)
#define SYSTEM_SLEEP_HOST_IF_MSB SOC_SYSTEM_SLEEP_HOST_IF_MSB
#define SYSTEM_SLEEP_HOST_IF_LSB SOC_SYSTEM_SLEEP_HOST_IF_LSB
#define SYSTEM_SLEEP_HOST_IF_MASK SOC_SYSTEM_SLEEP_HOST_IF_MASK
#define SYSTEM_SLEEP_HOST_IF_GET(x) SOC_SYSTEM_SLEEP_HOST_IF_GET(x)
#define SYSTEM_SLEEP_HOST_IF_SET(x) SOC_SYSTEM_SLEEP_HOST_IF_SET(x)
#define SYSTEM_SLEEP_MBOX_MSB SOC_SYSTEM_SLEEP_MBOX_MSB
#define SYSTEM_SLEEP_MBOX_LSB SOC_SYSTEM_SLEEP_MBOX_LSB
#define SYSTEM_SLEEP_MBOX_MASK SOC_SYSTEM_SLEEP_MBOX_MASK
#define SYSTEM_SLEEP_MBOX_GET(x) SOC_SYSTEM_SLEEP_MBOX_GET(x)
#define SYSTEM_SLEEP_MBOX_SET(x) SOC_SYSTEM_SLEEP_MBOX_SET(x)
#define SYSTEM_SLEEP_MAC_IF_MSB SOC_SYSTEM_SLEEP_MAC_IF_MSB
#define SYSTEM_SLEEP_MAC_IF_LSB SOC_SYSTEM_SLEEP_MAC_IF_LSB
#define SYSTEM_SLEEP_MAC_IF_MASK SOC_SYSTEM_SLEEP_MAC_IF_MASK
#define SYSTEM_SLEEP_MAC_IF_GET(x) SOC_SYSTEM_SLEEP_MAC_IF_GET(x)
#define SYSTEM_SLEEP_MAC_IF_SET(x) SOC_SYSTEM_SLEEP_MAC_IF_SET(x)
#define SYSTEM_SLEEP_LIGHT_MSB SOC_SYSTEM_SLEEP_LIGHT_MSB
#define SYSTEM_SLEEP_LIGHT_LSB SOC_SYSTEM_SLEEP_LIGHT_LSB
#define SYSTEM_SLEEP_LIGHT_MASK SOC_SYSTEM_SLEEP_LIGHT_MASK
#define SYSTEM_SLEEP_LIGHT_GET(x) SOC_SYSTEM_SLEEP_LIGHT_GET(x)
#define SYSTEM_SLEEP_LIGHT_SET(x) SOC_SYSTEM_SLEEP_LIGHT_SET(x)
#define SYSTEM_SLEEP_DISABLE_MSB SOC_SYSTEM_SLEEP_DISABLE_MSB
#define SYSTEM_SLEEP_DISABLE_LSB SOC_SYSTEM_SLEEP_DISABLE_LSB
#define SYSTEM_SLEEP_DISABLE_MASK SOC_SYSTEM_SLEEP_DISABLE_MASK
#define SYSTEM_SLEEP_DISABLE_GET(x) SOC_SYSTEM_SLEEP_DISABLE_GET(x)
#define SYSTEM_SLEEP_DISABLE_SET(x) SOC_SYSTEM_SLEEP_DISABLE_SET(x)
#define SDIO_WRAPPER_ADDRESS SOC_SDIO_WRAPPER_ADDRESS
#define SDIO_WRAPPER_OFFSET SOC_SDIO_WRAPPER_OFFSET
#define SDIO_WRAPPER_SLEEP_MSB SOC_SDIO_WRAPPER_SLEEP_MSB
#define SDIO_WRAPPER_SLEEP_LSB SOC_SDIO_WRAPPER_SLEEP_LSB
#define SDIO_WRAPPER_SLEEP_MASK SOC_SDIO_WRAPPER_SLEEP_MASK
#define SDIO_WRAPPER_SLEEP_GET(x) SOC_SDIO_WRAPPER_SLEEP_GET(x)
#define SDIO_WRAPPER_SLEEP_SET(x) SOC_SDIO_WRAPPER_SLEEP_SET(x)
#define SDIO_WRAPPER_WAKEUP_MSB SOC_SDIO_WRAPPER_WAKEUP_MSB
#define SDIO_WRAPPER_WAKEUP_LSB SOC_SDIO_WRAPPER_WAKEUP_LSB
#define SDIO_WRAPPER_WAKEUP_MASK SOC_SDIO_WRAPPER_WAKEUP_MASK
#define SDIO_WRAPPER_WAKEUP_GET(x) SOC_SDIO_WRAPPER_WAKEUP_GET(x)
#define SDIO_WRAPPER_WAKEUP_SET(x) SOC_SDIO_WRAPPER_WAKEUP_SET(x)
#define SDIO_WRAPPER_SOC_ON_MSB SOC_SDIO_WRAPPER_SOC_ON_MSB
#define SDIO_WRAPPER_SOC_ON_LSB SOC_SDIO_WRAPPER_SOC_ON_LSB
#define SDIO_WRAPPER_SOC_ON_MASK SOC_SDIO_WRAPPER_SOC_ON_MASK
#define SDIO_WRAPPER_SOC_ON_GET(x) SOC_SDIO_WRAPPER_SOC_ON_GET(x)
#define SDIO_WRAPPER_SOC_ON_SET(x) SOC_SDIO_WRAPPER_SOC_ON_SET(x)
#define SDIO_WRAPPER_ON_MSB SOC_SDIO_WRAPPER_ON_MSB
#define SDIO_WRAPPER_ON_LSB SOC_SDIO_WRAPPER_ON_LSB
#define SDIO_WRAPPER_ON_MASK SOC_SDIO_WRAPPER_ON_MASK
#define SDIO_WRAPPER_ON_GET(x) SOC_SDIO_WRAPPER_ON_GET(x)
#define SDIO_WRAPPER_ON_SET(x) SOC_SDIO_WRAPPER_ON_SET(x)
#define INT_STATUS1_ADDRESS SOC_INT_STATUS1_ADDRESS
#define INT_STATUS1_OFFSET SOC_INT_STATUS1_OFFSET
#define INT_STATUS1_I2S_1_MSB SOC_INT_STATUS1_I2S_1_MSB
#define INT_STATUS1_I2S_1_LSB SOC_INT_STATUS1_I2S_1_LSB
#define INT_STATUS1_I2S_1_MASK SOC_INT_STATUS1_I2S_1_MASK
#define INT_STATUS1_I2S_1_GET(x) SOC_INT_STATUS1_I2S_1_GET(x)
#define INT_STATUS1_I2S_1_SET(x) SOC_INT_STATUS1_I2S_1_SET(x)
#define INT_STATUS1_I2S_MSB SOC_INT_STATUS1_I2S_MSB
#define INT_STATUS1_I2S_LSB SOC_INT_STATUS1_I2S_LSB
#define INT_STATUS1_I2S_MASK SOC_INT_STATUS1_I2S_MASK
#define INT_STATUS1_I2S_GET(x) SOC_INT_STATUS1_I2S_GET(x)
#define INT_STATUS1_I2S_SET(x) SOC_INT_STATUS1_I2S_SET(x)
#define INT_STATUS1_MDIO_MSB SOC_INT_STATUS1_MDIO_MSB
#define INT_STATUS1_MDIO_LSB SOC_INT_STATUS1_MDIO_LSB
#define INT_STATUS1_MDIO_MASK SOC_INT_STATUS1_MDIO_MASK
#define INT_STATUS1_MDIO_GET(x) SOC_INT_STATUS1_MDIO_GET(x)
#define INT_STATUS1_MDIO_SET(x) SOC_INT_STATUS1_MDIO_SET(x)
#define INT_STATUS1_GMAC_MSB SOC_INT_STATUS1_GMAC_MSB
#define INT_STATUS1_GMAC_LSB SOC_INT_STATUS1_GMAC_LSB
#define INT_STATUS1_GMAC_MASK SOC_INT_STATUS1_GMAC_MASK
#define INT_STATUS1_GMAC_GET(x) SOC_INT_STATUS1_GMAC_GET(x)
#define INT_STATUS1_GMAC_SET(x) SOC_INT_STATUS1_GMAC_SET(x)
#define INT_STATUS1_I2C_S_MSB SOC_INT_STATUS1_I2C_S_MSB
#define INT_STATUS1_I2C_S_LSB SOC_INT_STATUS1_I2C_S_LSB
#define INT_STATUS1_I2C_S_MASK SOC_INT_STATUS1_I2C_S_MASK
#define INT_STATUS1_I2C_S_GET(x) SOC_INT_STATUS1_I2C_S_GET(x)
#define INT_STATUS1_I2C_S_SET(x) SOC_INT_STATUS1_I2C_S_SET(x)
#define INT_STATUS1_CKSUM_MSB SOC_INT_STATUS1_CKSUM_MSB
#define INT_STATUS1_CKSUM_LSB SOC_INT_STATUS1_CKSUM_LSB
#define INT_STATUS1_CKSUM_MASK SOC_INT_STATUS1_CKSUM_MASK
#define INT_STATUS1_CKSUM_GET(x) SOC_INT_STATUS1_CKSUM_GET(x)
#define INT_STATUS1_CKSUM_SET(x) SOC_INT_STATUS1_CKSUM_SET(x)
#define INT_STATUS1_MAC_4_MSB SOC_INT_STATUS1_MAC_4_MSB
#define INT_STATUS1_MAC_4_LSB SOC_INT_STATUS1_MAC_4_LSB
#define INT_STATUS1_MAC_4_MASK SOC_INT_STATUS1_MAC_4_MASK
#define INT_STATUS1_MAC_4_GET(x) SOC_INT_STATUS1_MAC_4_GET(x)
#define INT_STATUS1_MAC_4_SET(x) SOC_INT_STATUS1_MAC_4_SET(x)
#define INT_STATUS1_MAC_3_MSB SOC_INT_STATUS1_MAC_3_MSB
#define INT_STATUS1_MAC_3_LSB SOC_INT_STATUS1_MAC_3_LSB
#define INT_STATUS1_MAC_3_MASK SOC_INT_STATUS1_MAC_3_MASK
#define INT_STATUS1_MAC_3_GET(x) SOC_INT_STATUS1_MAC_3_GET(x)
#define INT_STATUS1_MAC_3_SET(x) SOC_INT_STATUS1_MAC_3_SET(x)
#define INT_STATUS1_MAC_2_MSB SOC_INT_STATUS1_MAC_2_MSB
#define INT_STATUS1_MAC_2_LSB SOC_INT_STATUS1_MAC_2_LSB
#define INT_STATUS1_MAC_2_MASK SOC_INT_STATUS1_MAC_2_MASK
#define INT_STATUS1_MAC_2_GET(x) SOC_INT_STATUS1_MAC_2_GET(x)
#define INT_STATUS1_MAC_2_SET(x) SOC_INT_STATUS1_MAC_2_SET(x)
#define INT_STATUS1_MAC_1_MSB SOC_INT_STATUS1_MAC_1_MSB
#define INT_STATUS1_MAC_1_LSB SOC_INT_STATUS1_MAC_1_LSB
#define INT_STATUS1_MAC_1_MASK SOC_INT_STATUS1_MAC_1_MASK
#define INT_STATUS1_MAC_1_GET(x) SOC_INT_STATUS1_MAC_1_GET(x)
#define INT_STATUS1_MAC_1_SET(x) SOC_INT_STATUS1_MAC_1_SET(x)
#define LPO_CAL_TIME_ADDRESS SOC_LPO_CAL_TIME_ADDRESS
#define LPO_CAL_TIME_OFFSET SOC_LPO_CAL_TIME_OFFSET
#define LPO_CAL_TIME_LENGTH_MSB SOC_LPO_CAL_TIME_LENGTH_MSB
#define LPO_CAL_TIME_LENGTH_LSB SOC_LPO_CAL_TIME_LENGTH_LSB
#define LPO_CAL_TIME_LENGTH_MASK SOC_LPO_CAL_TIME_LENGTH_MASK
#define LPO_CAL_TIME_LENGTH_GET(x) SOC_LPO_CAL_TIME_LENGTH_GET(x)
#define LPO_CAL_TIME_LENGTH_SET(x) SOC_LPO_CAL_TIME_LENGTH_SET(x)
#define LPO_INIT_DIVIDEND_INT_ADDRESS SOC_LPO_INIT_DIVIDEND_INT_ADDRESS
#define LPO_INIT_DIVIDEND_INT_OFFSET SOC_LPO_INIT_DIVIDEND_INT_OFFSET
#define LPO_INIT_DIVIDEND_INT_VALUE_MSB SOC_LPO_INIT_DIVIDEND_INT_VALUE_MSB
#define LPO_INIT_DIVIDEND_INT_VALUE_LSB SOC_LPO_INIT_DIVIDEND_INT_VALUE_LSB
#define LPO_INIT_DIVIDEND_INT_VALUE_MASK SOC_LPO_INIT_DIVIDEND_INT_VALUE_MASK
#define LPO_INIT_DIVIDEND_INT_VALUE_GET(x) SOC_LPO_INIT_DIVIDEND_INT_VALUE_GET(x)
#define LPO_INIT_DIVIDEND_INT_VALUE_SET(x) SOC_LPO_INIT_DIVIDEND_INT_VALUE_SET(x)
#define LPO_INIT_DIVIDEND_FRACTION_ADDRESS SOC_LPO_INIT_DIVIDEND_FRACTION_ADDRESS
#define LPO_INIT_DIVIDEND_FRACTION_OFFSET SOC_LPO_INIT_DIVIDEND_FRACTION_OFFSET
#define LPO_INIT_DIVIDEND_FRACTION_VALUE_MSB SOC_LPO_INIT_DIVIDEND_FRACTION_VALUE_MSB
#define LPO_INIT_DIVIDEND_FRACTION_VALUE_LSB SOC_LPO_INIT_DIVIDEND_FRACTION_VALUE_LSB
#define LPO_INIT_DIVIDEND_FRACTION_VALUE_MASK SOC_LPO_INIT_DIVIDEND_FRACTION_VALUE_MASK
#define LPO_INIT_DIVIDEND_FRACTION_VALUE_GET(x) SOC_LPO_INIT_DIVIDEND_FRACTION_VALUE_GET(x)
#define LPO_INIT_DIVIDEND_FRACTION_VALUE_SET(x) SOC_LPO_INIT_DIVIDEND_FRACTION_VALUE_SET(x)
#define LPO_CAL_ADDRESS SOC_LPO_CAL_ADDRESS
#define LPO_CAL_OFFSET SOC_LPO_CAL_OFFSET
#define LPO_CAL_ENABLE_MSB SOC_LPO_CAL_ENABLE_MSB
#define LPO_CAL_ENABLE_LSB SOC_LPO_CAL_ENABLE_LSB
#define LPO_CAL_ENABLE_MASK SOC_LPO_CAL_ENABLE_MASK
#define LPO_CAL_ENABLE_GET(x) SOC_LPO_CAL_ENABLE_GET(x)
#define LPO_CAL_ENABLE_SET(x) SOC_LPO_CAL_ENABLE_SET(x)
#define LPO_CAL_COUNT_MSB SOC_LPO_CAL_COUNT_MSB
#define LPO_CAL_COUNT_LSB SOC_LPO_CAL_COUNT_LSB
#define LPO_CAL_COUNT_MASK SOC_LPO_CAL_COUNT_MASK
#define LPO_CAL_COUNT_GET(x) SOC_LPO_CAL_COUNT_GET(x)
#define LPO_CAL_COUNT_SET(x) SOC_LPO_CAL_COUNT_SET(x)
#define LPO_CAL_TEST_CONTROL_ADDRESS SOC_LPO_CAL_TEST_CONTROL_ADDRESS
#define LPO_CAL_TEST_CONTROL_OFFSET SOC_LPO_CAL_TEST_CONTROL_OFFSET
#define LPO_CAL_TEST_CONTROL_ENABLE_MSB SOC_LPO_CAL_TEST_CONTROL_ENABLE_MSB
#define LPO_CAL_TEST_CONTROL_ENABLE_LSB SOC_LPO_CAL_TEST_CONTROL_ENABLE_LSB
#define LPO_CAL_TEST_CONTROL_ENABLE_MASK SOC_LPO_CAL_TEST_CONTROL_ENABLE_MASK
#define LPO_CAL_TEST_CONTROL_ENABLE_GET(x) SOC_LPO_CAL_TEST_CONTROL_ENABLE_GET(x)
#define LPO_CAL_TEST_CONTROL_ENABLE_SET(x) SOC_LPO_CAL_TEST_CONTROL_ENABLE_SET(x)
#define LPO_CAL_TEST_CONTROL_RTC_CYCLES_MSB SOC_LPO_CAL_TEST_CONTROL_RTC_CYCLES_MSB
#define LPO_CAL_TEST_CONTROL_RTC_CYCLES_LSB SOC_LPO_CAL_TEST_CONTROL_RTC_CYCLES_LSB
#define LPO_CAL_TEST_CONTROL_RTC_CYCLES_MASK SOC_LPO_CAL_TEST_CONTROL_RTC_CYCLES_MASK
#define LPO_CAL_TEST_CONTROL_RTC_CYCLES_GET(x) SOC_LPO_CAL_TEST_CONTROL_RTC_CYCLES_GET(x)
#define LPO_CAL_TEST_CONTROL_RTC_CYCLES_SET(x) SOC_LPO_CAL_TEST_CONTROL_RTC_CYCLES_SET(x)
#define LPO_CAL_TEST_STATUS_ADDRESS SOC_LPO_CAL_TEST_STATUS_ADDRESS
#define LPO_CAL_TEST_STATUS_OFFSET SOC_LPO_CAL_TEST_STATUS_OFFSET
#define LPO_CAL_TEST_STATUS_READY_MSB SOC_LPO_CAL_TEST_STATUS_READY_MSB
#define LPO_CAL_TEST_STATUS_READY_LSB SOC_LPO_CAL_TEST_STATUS_READY_LSB
#define LPO_CAL_TEST_STATUS_READY_MASK SOC_LPO_CAL_TEST_STATUS_READY_MASK
#define LPO_CAL_TEST_STATUS_READY_GET(x) SOC_LPO_CAL_TEST_STATUS_READY_GET(x)
#define LPO_CAL_TEST_STATUS_READY_SET(x) SOC_LPO_CAL_TEST_STATUS_READY_SET(x)
#define LPO_CAL_TEST_STATUS_COUNT_MSB SOC_LPO_CAL_TEST_STATUS_COUNT_MSB
#define LPO_CAL_TEST_STATUS_COUNT_LSB SOC_LPO_CAL_TEST_STATUS_COUNT_LSB
#define LPO_CAL_TEST_STATUS_COUNT_MASK SOC_LPO_CAL_TEST_STATUS_COUNT_MASK
#define LPO_CAL_TEST_STATUS_COUNT_GET(x) SOC_LPO_CAL_TEST_STATUS_COUNT_GET(x)
#define LPO_CAL_TEST_STATUS_COUNT_SET(x) SOC_LPO_CAL_TEST_STATUS_COUNT_SET(x)
#define CHIP_ID_ADDRESS SOC_CHIP_ID_ADDRESS
#define CHIP_ID_OFFSET SOC_CHIP_ID_OFFSET
#define CHIP_ID_DEVICE_ID_MSB SOC_CHIP_ID_DEVICE_ID_MSB
#define CHIP_ID_DEVICE_ID_LSB SOC_CHIP_ID_DEVICE_ID_LSB
#define CHIP_ID_DEVICE_ID_MASK SOC_CHIP_ID_DEVICE_ID_MASK
#define CHIP_ID_DEVICE_ID_GET(x) SOC_CHIP_ID_DEVICE_ID_GET(x)
#define CHIP_ID_DEVICE_ID_SET(x) SOC_CHIP_ID_DEVICE_ID_SET(x)
#define CHIP_ID_CONFIG_ID_MSB SOC_CHIP_ID_CONFIG_ID_MSB
#define CHIP_ID_CONFIG_ID_LSB SOC_CHIP_ID_CONFIG_ID_LSB
#define CHIP_ID_CONFIG_ID_MASK SOC_CHIP_ID_CONFIG_ID_MASK
#define CHIP_ID_CONFIG_ID_GET(x) SOC_CHIP_ID_CONFIG_ID_GET(x)
#define CHIP_ID_CONFIG_ID_SET(x) SOC_CHIP_ID_CONFIG_ID_SET(x)
#define CHIP_ID_VERSION_ID_MSB SOC_CHIP_ID_VERSION_ID_MSB
#define CHIP_ID_VERSION_ID_LSB SOC_CHIP_ID_VERSION_ID_LSB
#define CHIP_ID_VERSION_ID_MASK SOC_CHIP_ID_VERSION_ID_MASK
#define CHIP_ID_VERSION_ID_GET(x) SOC_CHIP_ID_VERSION_ID_GET(x)
#define CHIP_ID_VERSION_ID_SET(x) SOC_CHIP_ID_VERSION_ID_SET(x)
#define POWER_REG_ADDRESS SOC_POWER_REG_ADDRESS
#define POWER_REG_OFFSET SOC_POWER_REG_OFFSET
#define POWER_REG_SWREG_VS_EN_MSB SOC_POWER_REG_SWREG_VS_EN_MSB
#define POWER_REG_SWREG_VS_EN_LSB SOC_POWER_REG_SWREG_VS_EN_LSB
#define POWER_REG_SWREG_VS_EN_MASK SOC_POWER_REG_SWREG_VS_EN_MASK
#define POWER_REG_SWREG_VS_EN_GET(x) SOC_POWER_REG_SWREG_VS_EN_GET(x)
#define POWER_REG_SWREG_VS_EN_SET(x) SOC_POWER_REG_SWREG_VS_EN_SET(x)
#define POWER_REG_DISCON_MODE_EN_MSB SOC_POWER_REG_DISCON_MODE_EN_MSB
#define POWER_REG_DISCON_MODE_EN_LSB SOC_POWER_REG_DISCON_MODE_EN_LSB
#define POWER_REG_DISCON_MODE_EN_MASK SOC_POWER_REG_DISCON_MODE_EN_MASK
#define POWER_REG_DISCON_MODE_EN_GET(x) SOC_POWER_REG_DISCON_MODE_EN_GET(x)
#define POWER_REG_DISCON_MODE_EN_SET(x) SOC_POWER_REG_DISCON_MODE_EN_SET(x)
#define POWER_REG_DEEP_SLEEP_EN_MSB SOC_POWER_REG_DEEP_SLEEP_EN_MSB
#define POWER_REG_DEEP_SLEEP_EN_LSB SOC_POWER_REG_DEEP_SLEEP_EN_LSB
#define POWER_REG_DEEP_SLEEP_EN_MASK SOC_POWER_REG_DEEP_SLEEP_EN_MASK
#define POWER_REG_DEEP_SLEEP_EN_GET(x) SOC_POWER_REG_DEEP_SLEEP_EN_GET(x)
#define POWER_REG_DEEP_SLEEP_EN_SET(x) SOC_POWER_REG_DEEP_SLEEP_EN_SET(x)
#define POWER_REG_DEBUG_EN_MSB SOC_POWER_REG_DEBUG_EN_MSB
#define POWER_REG_DEBUG_EN_LSB SOC_POWER_REG_DEBUG_EN_LSB
#define POWER_REG_DEBUG_EN_MASK SOC_POWER_REG_DEBUG_EN_MASK
#define POWER_REG_DEBUG_EN_GET(x) SOC_POWER_REG_DEBUG_EN_GET(x)
#define POWER_REG_DEBUG_EN_SET(x) SOC_POWER_REG_DEBUG_EN_SET(x)
#define POWER_REG_WLAN_BB_PWD_EN_MSB SOC_POWER_REG_WLAN_BB_PWD_EN_MSB
#define POWER_REG_WLAN_BB_PWD_EN_LSB SOC_POWER_REG_WLAN_BB_PWD_EN_LSB
#define POWER_REG_WLAN_BB_PWD_EN_MASK SOC_POWER_REG_WLAN_BB_PWD_EN_MASK
#define POWER_REG_WLAN_BB_PWD_EN_GET(x) SOC_POWER_REG_WLAN_BB_PWD_EN_GET(x)
#define POWER_REG_WLAN_BB_PWD_EN_SET(x) SOC_POWER_REG_WLAN_BB_PWD_EN_SET(x)
#define POWER_REG_WLAN_MAC_PWD_EN_MSB SOC_POWER_REG_WLAN_MAC_PWD_EN_MSB
#define POWER_REG_WLAN_MAC_PWD_EN_LSB SOC_POWER_REG_WLAN_MAC_PWD_EN_LSB
#define POWER_REG_WLAN_MAC_PWD_EN_MASK SOC_POWER_REG_WLAN_MAC_PWD_EN_MASK
#define POWER_REG_WLAN_MAC_PWD_EN_GET(x) SOC_POWER_REG_WLAN_MAC_PWD_EN_GET(x)
#define POWER_REG_WLAN_MAC_PWD_EN_SET(x) SOC_POWER_REG_WLAN_MAC_PWD_EN_SET(x)
#define POWER_REG_CPU_INT_ENABLE_MSB SOC_POWER_REG_CPU_INT_ENABLE_MSB
#define POWER_REG_CPU_INT_ENABLE_LSB SOC_POWER_REG_CPU_INT_ENABLE_LSB
#define POWER_REG_CPU_INT_ENABLE_MASK SOC_POWER_REG_CPU_INT_ENABLE_MASK
#define POWER_REG_CPU_INT_ENABLE_GET(x) SOC_POWER_REG_CPU_INT_ENABLE_GET(x)
#define POWER_REG_CPU_INT_ENABLE_SET(x) SOC_POWER_REG_CPU_INT_ENABLE_SET(x)
#define POWER_REG_RADIO_PWD_EN_MSB SOC_POWER_REG_RADIO_PWD_EN_MSB
#define POWER_REG_RADIO_PWD_EN_LSB SOC_POWER_REG_RADIO_PWD_EN_LSB
#define POWER_REG_RADIO_PWD_EN_MASK SOC_POWER_REG_RADIO_PWD_EN_MASK
#define POWER_REG_RADIO_PWD_EN_GET(x) SOC_POWER_REG_RADIO_PWD_EN_GET(x)
#define POWER_REG_RADIO_PWD_EN_SET(x) SOC_POWER_REG_RADIO_PWD_EN_SET(x)
#define POWER_REG_WLAN_PWD_EN_MSB SOC_POWER_REG_WLAN_PWD_EN_MSB
#define POWER_REG_WLAN_PWD_EN_LSB SOC_POWER_REG_WLAN_PWD_EN_LSB
#define POWER_REG_WLAN_PWD_EN_MASK SOC_POWER_REG_WLAN_PWD_EN_MASK
#define POWER_REG_WLAN_PWD_EN_GET(x) SOC_POWER_REG_WLAN_PWD_EN_GET(x)
#define POWER_REG_WLAN_PWD_EN_SET(x) SOC_POWER_REG_WLAN_PWD_EN_SET(x)
#define POWER_REG_POWER_EN_MSB SOC_POWER_REG_POWER_EN_MSB
#define POWER_REG_POWER_EN_LSB SOC_POWER_REG_POWER_EN_LSB
#define POWER_REG_POWER_EN_MASK SOC_POWER_REG_POWER_EN_MASK
#define POWER_REG_POWER_EN_GET(x) SOC_POWER_REG_POWER_EN_GET(x)
#define POWER_REG_POWER_EN_SET(x) SOC_POWER_REG_POWER_EN_SET(x)
#define CORE_CLK_CTRL_ADDRESS SOC_CORE_CLK_CTRL_ADDRESS
#define CORE_CLK_CTRL_OFFSET SOC_CORE_CLK_CTRL_OFFSET
#define CORE_CLK_CTRL_DIV_MSB SOC_CORE_CLK_CTRL_DIV_MSB
#define CORE_CLK_CTRL_DIV_LSB SOC_CORE_CLK_CTRL_DIV_LSB
#define CORE_CLK_CTRL_DIV_MASK SOC_CORE_CLK_CTRL_DIV_MASK
#define CORE_CLK_CTRL_DIV_GET(x) SOC_CORE_CLK_CTRL_DIV_GET(x)
#define CORE_CLK_CTRL_DIV_SET(x) SOC_CORE_CLK_CTRL_DIV_SET(x)
#define GPIO_WAKEUP_CONTROL_ADDRESS SOC_GPIO_WAKEUP_CONTROL_ADDRESS
#define GPIO_WAKEUP_CONTROL_OFFSET SOC_GPIO_WAKEUP_CONTROL_OFFSET
#define GPIO_WAKEUP_CONTROL_ENABLE_MSB SOC_GPIO_WAKEUP_CONTROL_ENABLE_MSB
#define GPIO_WAKEUP_CONTROL_ENABLE_LSB SOC_GPIO_WAKEUP_CONTROL_ENABLE_LSB
#define GPIO_WAKEUP_CONTROL_ENABLE_MASK SOC_GPIO_WAKEUP_CONTROL_ENABLE_MASK
#define GPIO_WAKEUP_CONTROL_ENABLE_GET(x) SOC_GPIO_WAKEUP_CONTROL_ENABLE_GET(x)
#define GPIO_WAKEUP_CONTROL_ENABLE_SET(x) SOC_GPIO_WAKEUP_CONTROL_ENABLE_SET(x)


#endif
#endif



